// Code generated by pigeon; DO NOT EDIT.

package nosql

import (
	"bytes"
	"errors"
	"fmt"
	"io"
	"math"
	"os"
	"sort"
	"strconv"
	"strings"
	"sync"
	"unicode"
	"unicode/utf8"

	"github.com/pikami/cosmium/parsers"
)

func makeSelectStmt(
	columns, table,
	whereClause interface{}, distinctClause interface{},
	count interface{}, groupByClause interface{}, orderList interface{},
) (parsers.SelectStmt, error) {
	selectStmt := parsers.SelectStmt{
		SelectItems: columns.([]parsers.SelectItem),
		Table:       table.(parsers.Table),
	}

	switch v := whereClause.(type) {
	case parsers.ComparisonExpression, parsers.LogicalExpression, parsers.Constant, parsers.SelectItem:
		selectStmt.Filters = v
	}

	if distinctClause != nil {
		selectStmt.Distinct = true
	}

	if n, ok := count.(int); ok {
		selectStmt.Count = n
	}

	if orderExpressions, ok := orderList.([]parsers.OrderExpression); ok {
		selectStmt.OrderExpressions = orderExpressions
	}

	if groupByClause != nil {
		selectStmt.GroupBy = groupByClause.([]parsers.SelectItem)
	}

	return selectStmt, nil
}

func makeSelectItem(name interface{}, path interface{}, selectItemType parsers.SelectItemType) (parsers.SelectItem, error) {
	ps := path.([]interface{})

	paths := make([]string, 1)
	paths[0] = name.(string)
	for _, p := range ps {
		paths = append(paths, p.(string))
	}

	return parsers.SelectItem{Path: paths, Type: selectItemType}, nil
}

func makeColumnList(column interface{}, other_columns interface{}) ([]parsers.SelectItem, error) {
	collsAsArray := other_columns.([]interface{})
	columnList := make([]parsers.SelectItem, len(collsAsArray)+1)
	columnList[0] = column.(parsers.SelectItem)

	for i, v := range collsAsArray {
		if col, ok := v.(parsers.SelectItem); ok {
			columnList[i+1] = col
		}
	}

	return columnList, nil
}

func makeSelectArray(columns interface{}) (parsers.SelectItem, error) {
	return parsers.SelectItem{
		SelectItems: columns.([]parsers.SelectItem),
		Type:        parsers.SelectItemTypeArray,
	}, nil
}

func makeSelectObject(field interface{}, other_fields interface{}) (parsers.SelectItem, error) {
	fieldsAsArray := other_fields.([]interface{})
	fieldsList := make([]parsers.SelectItem, len(fieldsAsArray)+1)
	fieldsList[0] = field.(parsers.SelectItem)

	for i, v := range fieldsAsArray {
		if col, ok := v.(parsers.SelectItem); ok {
			fieldsList[i+1] = col
		}
	}

	return parsers.SelectItem{
		SelectItems: fieldsList,
		Type:        parsers.SelectItemTypeObject,
	}, nil
}

func makeOrderByClause(ex1 interface{}, others interface{}) ([]parsers.OrderExpression, error) {
	othersArray := others.([]interface{})
	orderList := make([]parsers.OrderExpression, len(othersArray)+1)
	orderList[0] = ex1.(parsers.OrderExpression)

	for i, v := range othersArray {
		if col, ok := v.(parsers.OrderExpression); ok {
			orderList[i+1] = col
		}
	}

	return orderList, nil
}

func makeOrderExpression(field interface{}, order interface{}) (parsers.OrderExpression, error) {
	value := parsers.OrderExpression{
		SelectItem: field.(parsers.SelectItem),
		Direction:  parsers.OrderDirectionAsc,
	}

	if orderValue, ok := order.(parsers.OrderDirection); ok {
		value.Direction = orderValue
	}

	return value, nil
}

func createFunctionCall(functionType parsers.FunctionCallType, arguments []interface{}) (parsers.FunctionCall, error) {
	return parsers.FunctionCall{Type: functionType, Arguments: arguments}, nil
}

func joinStrings(array []interface{}) string {
	var stringsArray []string
	for _, elem := range array {
		str, ok := elem.(string)
		if !ok {
			continue
		}
		stringsArray = append(stringsArray, str)
	}

	return strings.Join(stringsArray, "")
}

func combineExpressions(ex1 interface{}, exs interface{}, operation parsers.LogicalExpressionType) (interface{}, error) {
	if exs == nil || len(exs.([]interface{})) < 1 {
		return ex1, nil
	}

	return parsers.LogicalExpression{
		Expressions: append([]interface{}{ex1}, exs.([]interface{})...),
		Operation:   operation,
	}, nil
}

var g = &grammar{
	rules: []*rule{
		{
			name: "Input",
			pos:  position{line: 147, col: 1, offset: 3952},
			expr: &actionExpr{
				pos: position{line: 147, col: 10, offset: 3961},
				run: (*parser).callonInput1,
				expr: &labeledExpr{
					pos:   position{line: 147, col: 10, offset: 3961},
					label: "selectStmt",
					expr: &ruleRefExpr{
						pos:  position{line: 147, col: 21, offset: 3972},
						name: "SelectStmt",
					},
				},
			},
		},
		{
			name: "SelectStmt",
			pos:  position{line: 151, col: 1, offset: 4015},
			expr: &actionExpr{
				pos: position{line: 151, col: 15, offset: 4029},
				run: (*parser).callonSelectStmt1,
				expr: &seqExpr{
					pos: position{line: 151, col: 15, offset: 4029},
					exprs: []any{
						&ruleRefExpr{
							pos:  position{line: 151, col: 15, offset: 4029},
							name: "Select",
						},
						&ruleRefExpr{
							pos:  position{line: 151, col: 22, offset: 4036},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 152, col: 5, offset: 4043},
							label: "distinctClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 152, col: 20, offset: 4058},
								expr: &ruleRefExpr{
									pos:  position{line: 152, col: 20, offset: 4058},
									name: "DistinctClause",
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 152, col: 36, offset: 4074},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 153, col: 5, offset: 4081},
							label: "topClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 153, col: 15, offset: 4091},
								expr: &ruleRefExpr{
									pos:  position{line: 153, col: 15, offset: 4091},
									name: "TopClause",
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 153, col: 26, offset: 4102},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 153, col: 29, offset: 4105},
							label: "columns",
							expr: &ruleRefExpr{
								pos:  position{line: 153, col: 37, offset: 4113},
								name: "Selection",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 153, col: 47, offset: 4123},
							name: "ws",
						},
						&ruleRefExpr{
							pos:  position{line: 154, col: 5, offset: 4130},
							name: "From",
						},
						&ruleRefExpr{
							pos:  position{line: 154, col: 10, offset: 4135},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 154, col: 13, offset: 4138},
							label: "table",
							expr: &ruleRefExpr{
								pos:  position{line: 154, col: 19, offset: 4144},
								name: "TableName",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 154, col: 29, offset: 4154},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 155, col: 5, offset: 4161},
							label: "whereClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 155, col: 17, offset: 4173},
								expr: &actionExpr{
									pos: position{line: 155, col: 18, offset: 4174},
									run: (*parser).callonSelectStmt23,
									expr: &seqExpr{
										pos: position{line: 155, col: 18, offset: 4174},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 155, col: 18, offset: 4174},
												name: "ws",
											},
											&ruleRefExpr{
												pos:  position{line: 155, col: 21, offset: 4177},
												name: "Where",
											},
											&ruleRefExpr{
												pos:  position{line: 155, col: 27, offset: 4183},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 155, col: 30, offset: 4186},
												label: "condition",
												expr: &ruleRefExpr{
													pos:  position{line: 155, col: 40, offset: 4196},
													name: "Condition",
												},
											},
										},
									},
								},
							},
						},
						&labeledExpr{
							pos:   position{line: 156, col: 5, offset: 4238},
							label: "groupByClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 156, col: 19, offset: 4252},
								expr: &actionExpr{
									pos: position{line: 156, col: 20, offset: 4253},
									run: (*parser).callonSelectStmt32,
									expr: &seqExpr{
										pos: position{line: 156, col: 20, offset: 4253},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 156, col: 20, offset: 4253},
												name: "ws",
											},
											&ruleRefExpr{
												pos:  position{line: 156, col: 23, offset: 4256},
												name: "GroupBy",
											},
											&ruleRefExpr{
												pos:  position{line: 156, col: 31, offset: 4264},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 156, col: 34, offset: 4267},
												label: "columns",
												expr: &ruleRefExpr{
													pos:  position{line: 156, col: 42, offset: 4275},
													name: "ColumnList",
												},
											},
										},
									},
								},
							},
						},
						&labeledExpr{
							pos:   position{line: 157, col: 5, offset: 4316},
							label: "orderByClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 157, col: 19, offset: 4330},
								expr: &ruleRefExpr{
									pos:  position{line: 157, col: 19, offset: 4330},
									name: "OrderByClause",
								},
							},
						},
					},
				},
			},
		},
		{
			name: "DistinctClause",
			pos:  position{line: 162, col: 1, offset: 4470},
			expr: &litMatcher{
				pos:        position{line: 162, col: 19, offset: 4488},
				val:        "distinct",
				ignoreCase: true,
				want:       "\"DISTINCT\"i",
			},
		},
		{
			name: "TopClause",
			pos:  position{line: 164, col: 1, offset: 4501},
			expr: &actionExpr{
				pos: position{line: 164, col: 14, offset: 4514},
				run: (*parser).callonTopClause1,
				expr: &seqExpr{
					pos: position{line: 164, col: 14, offset: 4514},
					exprs: []any{
						&ruleRefExpr{
							pos:  position{line: 164, col: 14, offset: 4514},
							name: "Top",
						},
						&ruleRefExpr{
							pos:  position{line: 164, col: 18, offset: 4518},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 164, col: 21, offset: 4521},
							label: "count",
							expr: &ruleRefExpr{
								pos:  position{line: 164, col: 27, offset: 4527},
								name: "Integer",
							},
						},
					},
				},
			},
		},
		{
			name: "Selection",
			pos:  position{line: 168, col: 1, offset: 4562},
			expr: &choiceExpr{
				pos: position{line: 168, col: 14, offset: 4575},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 168, col: 14, offset: 4575},
						name: "SelectValueSpec",
					},
					&ruleRefExpr{
						pos:  position{line: 168, col: 32, offset: 4593},
						name: "ColumnList",
					},
					&ruleRefExpr{
						pos:  position{line: 168, col: 45, offset: 4606},
						name: "SelectAsterisk",
					},
				},
			},
		},
		{
			name: "SelectAsterisk",
			pos:  position{line: 170, col: 1, offset: 4622},
			expr: &actionExpr{
				pos: position{line: 170, col: 19, offset: 4640},
				run: (*parser).callonSelectAsterisk1,
				expr: &litMatcher{
					pos:        position{line: 170, col: 19, offset: 4640},
					val:        "*",
					ignoreCase: false,
					want:       "\"*\"",
				},
			},
		},
		{
			name: "ColumnList",
			pos:  position{line: 176, col: 1, offset: 4835},
			expr: &actionExpr{
				pos: position{line: 176, col: 15, offset: 4849},
				run: (*parser).callonColumnList1,
				expr: &seqExpr{
					pos: position{line: 176, col: 15, offset: 4849},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 176, col: 15, offset: 4849},
							label: "column",
							expr: &ruleRefExpr{
								pos:  position{line: 176, col: 22, offset: 4856},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 176, col: 33, offset: 4867},
							label: "other_columns",
							expr: &zeroOrMoreExpr{
								pos: position{line: 176, col: 47, offset: 4881},
								expr: &actionExpr{
									pos: position{line: 176, col: 48, offset: 4882},
									run: (*parser).callonColumnList7,
									expr: &seqExpr{
										pos: position{line: 176, col: 48, offset: 4882},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 176, col: 48, offset: 4882},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 176, col: 51, offset: 4885},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 176, col: 55, offset: 4889},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 176, col: 58, offset: 4892},
												label: "coll",
												expr: &ruleRefExpr{
													pos:  position{line: 176, col: 63, offset: 4897},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "SelectValueSpec",
			pos:  position{line: 180, col: 1, offset: 4984},
			expr: &actionExpr{
				pos: position{line: 180, col: 20, offset: 5003},
				run: (*parser).callonSelectValueSpec1,
				expr: &seqExpr{
					pos: position{line: 180, col: 20, offset: 5003},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 180, col: 20, offset: 5003},
							val:        "value",
							ignoreCase: true,
							want:       "\"VALUE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 180, col: 29, offset: 5012},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 180, col: 32, offset: 5015},
							label: "column",
							expr: &ruleRefExpr{
								pos:  position{line: 180, col: 39, offset: 5022},
								name: "SelectItem",
							},
						},
					},
				},
			},
		},
		{
			name: "TableName",
			pos:  position{line: 186, col: 1, offset: 5176},
			expr: &actionExpr{
				pos: position{line: 186, col: 14, offset: 5189},
				run: (*parser).callonTableName1,
				expr: &labeledExpr{
					pos:   position{line: 186, col: 14, offset: 5189},
					label: "key",
					expr: &ruleRefExpr{
						pos:  position{line: 186, col: 18, offset: 5193},
						name: "Identifier",
					},
				},
			},
		},
		{
			name: "SelectArray",
			pos:  position{line: 190, col: 1, offset: 5260},
			expr: &actionExpr{
				pos: position{line: 190, col: 16, offset: 5275},
				run: (*parser).callonSelectArray1,
				expr: &seqExpr{
					pos: position{line: 190, col: 16, offset: 5275},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 190, col: 16, offset: 5275},
							val:        "[",
							ignoreCase: false,
							want:       "\"[\"",
						},
						&ruleRefExpr{
							pos:  position{line: 190, col: 20, offset: 5279},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 190, col: 23, offset: 5282},
							label: "columns",
							expr: &ruleRefExpr{
								pos:  position{line: 190, col: 31, offset: 5290},
								name: "ColumnList",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 190, col: 42, offset: 5301},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 190, col: 45, offset: 5304},
							val:        "]",
							ignoreCase: false,
							want:       "\"]\"",
						},
					},
				},
			},
		},
		{
			name: "SelectObject",
			pos:  position{line: 194, col: 1, offset: 5349},
			expr: &actionExpr{
				pos: position{line: 194, col: 17, offset: 5365},
				run: (*parser).callonSelectObject1,
				expr: &seqExpr{
					pos: position{line: 194, col: 17, offset: 5365},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 194, col: 17, offset: 5365},
							val:        "{",
							ignoreCase: false,
							want:       "\"{\"",
						},
						&ruleRefExpr{
							pos:  position{line: 194, col: 21, offset: 5369},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 194, col: 24, offset: 5372},
							label: "field",
							expr: &ruleRefExpr{
								pos:  position{line: 194, col: 30, offset: 5378},
								name: "SelectObjectField",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 194, col: 48, offset: 5396},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 194, col: 51, offset: 5399},
							label: "other_fields",
							expr: &zeroOrMoreExpr{
								pos: position{line: 194, col: 64, offset: 5412},
								expr: &actionExpr{
									pos: position{line: 194, col: 65, offset: 5413},
									run: (*parser).callonSelectObject10,
									expr: &seqExpr{
										pos: position{line: 194, col: 65, offset: 5413},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 194, col: 65, offset: 5413},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 194, col: 68, offset: 5416},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 194, col: 72, offset: 5420},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 194, col: 75, offset: 5423},
												label: "coll",
												expr: &ruleRefExpr{
													pos:  position{line: 194, col: 80, offset: 5428},
													name: "SelectObjectField",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 194, col: 120, offset: 5468},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 194, col: 123, offset: 5471},
							val:        "}",
							ignoreCase: false,
							want:       "\"}\"",
						},
					},
				},
			},
		},
		{
			name: "SelectObjectField",
			pos:  position{line: 198, col: 1, offset: 5529},
			expr: &actionExpr{
				pos: position{line: 198, col: 22, offset: 5550},
				run: (*parser).callonSelectObjectField1,
				expr: &seqExpr{
					pos: position{line: 198, col: 22, offset: 5550},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 198, col: 22, offset: 5550},
							label: "name",
							expr: &choiceExpr{
								pos: position{line: 198, col: 28, offset: 5556},
								alternatives: []any{
									&ruleRefExpr{
										pos:  position{line: 198, col: 28, offset: 5556},
										name: "Identifier",
									},
									&actionExpr{
										pos: position{line: 198, col: 41, offset: 5569},
										run: (*parser).callonSelectObjectField6,
										expr: &seqExpr{
											pos: position{line: 198, col: 41, offset: 5569},
											exprs: []any{
												&litMatcher{
													pos:        position{line: 198, col: 41, offset: 5569},
													val:        "\"",
													ignoreCase: false,
													want:       "\"\\\"\"",
												},
												&labeledExpr{
													pos:   position{line: 198, col: 46, offset: 5574},
													label: "key",
													expr: &ruleRefExpr{
														pos:  position{line: 198, col: 50, offset: 5578},
														name: "Identifier",
													},
												},
												&litMatcher{
													pos:        position{line: 198, col: 61, offset: 5589},
													val:        "\"",
													ignoreCase: false,
													want:       "\"\\\"\"",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 198, col: 87, offset: 5615},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 198, col: 90, offset: 5618},
							val:        ":",
							ignoreCase: false,
							want:       "\":\"",
						},
						&ruleRefExpr{
							pos:  position{line: 198, col: 94, offset: 5622},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 198, col: 97, offset: 5625},
							label: "selectItem",
							expr: &ruleRefExpr{
								pos:  position{line: 198, col: 108, offset: 5636},
								name: "SelectItem",
							},
						},
					},
				},
			},
		},
		{
			name: "SelectProperty",
			pos:  position{line: 204, col: 1, offset: 5742},
			expr: &actionExpr{
				pos: position{line: 204, col: 19, offset: 5760},
				run: (*parser).callonSelectProperty1,
				expr: &seqExpr{
					pos: position{line: 204, col: 19, offset: 5760},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 204, col: 19, offset: 5760},
							label: "name",
							expr: &ruleRefExpr{
								pos:  position{line: 204, col: 24, offset: 5765},
								name: "Identifier",
							},
						},
						&labeledExpr{
							pos:   position{line: 204, col: 35, offset: 5776},
							label: "path",
							expr: &zeroOrMoreExpr{
								pos: position{line: 204, col: 40, offset: 5781},
								expr: &choiceExpr{
									pos: position{line: 204, col: 41, offset: 5782},
									alternatives: []any{
										&ruleRefExpr{
											pos:  position{line: 204, col: 41, offset: 5782},
											name: "DotFieldAccess",
										},
										&ruleRefExpr{
											pos:  position{line: 204, col: 58, offset: 5799},
											name: "ArrayFieldAccess",
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "SelectItem",
			pos:  position{line: 208, col: 1, offset: 5890},
			expr: &actionExpr{
				pos: position{line: 208, col: 15, offset: 5904},
				run: (*parser).callonSelectItem1,
				expr: &seqExpr{
					pos: position{line: 208, col: 15, offset: 5904},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 208, col: 15, offset: 5904},
							label: "selectItem",
							expr: &choiceExpr{
								pos: position{line: 208, col: 27, offset: 5916},
								alternatives: []any{
									&ruleRefExpr{
										pos:  position{line: 208, col: 27, offset: 5916},
										name: "Literal",
									},
									&ruleRefExpr{
										pos:  position{line: 208, col: 37, offset: 5926},
										name: "FunctionCall",
									},
									&ruleRefExpr{
										pos:  position{line: 208, col: 52, offset: 5941},
										name: "SelectArray",
									},
									&ruleRefExpr{
										pos:  position{line: 208, col: 66, offset: 5955},
										name: "SelectObject",
									},
									&ruleRefExpr{
										pos:  position{line: 208, col: 81, offset: 5970},
										name: "SelectProperty",
									},
								},
							},
						},
						&labeledExpr{
							pos:   position{line: 208, col: 97, offset: 5986},
							label: "asClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 208, col: 106, offset: 5995},
								expr: &ruleRefExpr{
									pos:  position{line: 208, col: 106, offset: 5995},
									name: "AsClause",
								},
							},
						},
					},
				},
			},
		},
		{
			name: "AsClause",
			pos:  position{line: 232, col: 1, offset: 6593},
			expr: &actionExpr{
				pos: position{line: 232, col: 13, offset: 6605},
				run: (*parser).callonAsClause1,
				expr: &seqExpr{
					pos: position{line: 232, col: 13, offset: 6605},
					exprs: []any{
						&ruleRefExpr{
							pos:  position{line: 232, col: 13, offset: 6605},
							name: "ws",
						},
						&ruleRefExpr{
							pos:  position{line: 232, col: 16, offset: 6608},
							name: "As",
						},
						&ruleRefExpr{
							pos:  position{line: 232, col: 19, offset: 6611},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 232, col: 22, offset: 6614},
							label: "alias",
							expr: &ruleRefExpr{
								pos:  position{line: 232, col: 28, offset: 6620},
								name: "Identifier",
							},
						},
					},
				},
			},
		},
		{
			name: "DotFieldAccess",
			pos:  position{line: 234, col: 1, offset: 6654},
			expr: &actionExpr{
				pos: position{line: 234, col: 19, offset: 6672},
				run: (*parser).callonDotFieldAccess1,
				expr: &seqExpr{
					pos: position{line: 234, col: 19, offset: 6672},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 234, col: 19, offset: 6672},
							val:        ".",
							ignoreCase: false,
							want:       "\".\"",
						},
						&labeledExpr{
							pos:   position{line: 234, col: 23, offset: 6676},
							label: "id",
							expr: &ruleRefExpr{
								pos:  position{line: 234, col: 26, offset: 6679},
								name: "Identifier",
							},
						},
					},
				},
			},
		},
		{
			name: "ArrayFieldAccess",
			pos:  position{line: 238, col: 1, offset: 6714},
			expr: &actionExpr{
				pos: position{line: 238, col: 21, offset: 6734},
				run: (*parser).callonArrayFieldAccess1,
				expr: &seqExpr{
					pos: position{line: 238, col: 21, offset: 6734},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 238, col: 21, offset: 6734},
							val:        "[\"",
							ignoreCase: false,
							want:       "\"[\\\"\"",
						},
						&labeledExpr{
							pos:   position{line: 238, col: 27, offset: 6740},
							label: "id",
							expr: &ruleRefExpr{
								pos:  position{line: 238, col: 30, offset: 6743},
								name: "Identifier",
							},
						},
						&litMatcher{
							pos:        position{line: 238, col: 41, offset: 6754},
							val:        "\"]",
							ignoreCase: false,
							want:       "\"\\\"]\"",
						},
					},
				},
			},
		},
		{
			name: "Identifier",
			pos:  position{line: 242, col: 1, offset: 6784},
			expr: &actionExpr{
				pos: position{line: 242, col: 15, offset: 6798},
				run: (*parser).callonIdentifier1,
				expr: &seqExpr{
					pos: position{line: 242, col: 15, offset: 6798},
					exprs: []any{
						&charClassMatcher{
							pos:        position{line: 242, col: 15, offset: 6798},
							val:        "[a-zA-Z_]",
							chars:      []rune{'_'},
							ranges:     []rune{'a', 'z', 'A', 'Z'},
							ignoreCase: false,
							inverted:   false,
						},
						&zeroOrMoreExpr{
							pos: position{line: 242, col: 24, offset: 6807},
							expr: &charClassMatcher{
								pos:        position{line: 242, col: 24, offset: 6807},
								val:        "[a-zA-Z0-9_]",
								chars:      []rune{'_'},
								ranges:     []rune{'a', 'z', 'A', 'Z', '0', '9'},
								ignoreCase: false,
								inverted:   false,
							},
						},
					},
				},
			},
		},
		{
			name: "Condition",
			pos:  position{line: 246, col: 1, offset: 6857},
			expr: &actionExpr{
				pos: position{line: 246, col: 14, offset: 6870},
				run: (*parser).callonCondition1,
				expr: &labeledExpr{
					pos:   position{line: 246, col: 14, offset: 6870},
					label: "expression",
					expr: &ruleRefExpr{
						pos:  position{line: 246, col: 25, offset: 6881},
						name: "OrExpression",
					},
				},
			},
		},
		{
			name: "OrExpression",
			pos:  position{line: 250, col: 1, offset: 6926},
			expr: &actionExpr{
				pos: position{line: 250, col: 17, offset: 6942},
				run: (*parser).callonOrExpression1,
				expr: &seqExpr{
					pos: position{line: 250, col: 17, offset: 6942},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 250, col: 17, offset: 6942},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 250, col: 21, offset: 6946},
								name: "AndExpression",
							},
						},
						&labeledExpr{
							pos:   position{line: 250, col: 35, offset: 6960},
							label: "ex2",
							expr: &zeroOrMoreExpr{
								pos: position{line: 250, col: 39, offset: 6964},
								expr: &actionExpr{
									pos: position{line: 250, col: 40, offset: 6965},
									run: (*parser).callonOrExpression7,
									expr: &seqExpr{
										pos: position{line: 250, col: 40, offset: 6965},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 250, col: 40, offset: 6965},
												name: "ws",
											},
											&ruleRefExpr{
												pos:  position{line: 250, col: 43, offset: 6968},
												name: "Or",
											},
											&ruleRefExpr{
												pos:  position{line: 250, col: 46, offset: 6971},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 250, col: 49, offset: 6974},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 250, col: 52, offset: 6977},
													name: "AndExpression",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "AndExpression",
			pos:  position{line: 254, col: 1, offset: 7090},
			expr: &actionExpr{
				pos: position{line: 254, col: 18, offset: 7107},
				run: (*parser).callonAndExpression1,
				expr: &seqExpr{
					pos: position{line: 254, col: 18, offset: 7107},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 254, col: 18, offset: 7107},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 254, col: 22, offset: 7111},
								name: "ComparisonExpression",
							},
						},
						&labeledExpr{
							pos:   position{line: 254, col: 43, offset: 7132},
							label: "ex2",
							expr: &zeroOrMoreExpr{
								pos: position{line: 254, col: 47, offset: 7136},
								expr: &actionExpr{
									pos: position{line: 254, col: 48, offset: 7137},
									run: (*parser).callonAndExpression7,
									expr: &seqExpr{
										pos: position{line: 254, col: 48, offset: 7137},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 254, col: 48, offset: 7137},
												name: "ws",
											},
											&ruleRefExpr{
												pos:  position{line: 254, col: 51, offset: 7140},
												name: "And",
											},
											&ruleRefExpr{
												pos:  position{line: 254, col: 55, offset: 7144},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 254, col: 58, offset: 7147},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 254, col: 61, offset: 7150},
													name: "ComparisonExpression",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "ComparisonExpression",
			pos:  position{line: 258, col: 1, offset: 7271},
			expr: &choiceExpr{
				pos: position{line: 258, col: 25, offset: 7295},
				alternatives: []any{
					&actionExpr{
						pos: position{line: 258, col: 25, offset: 7295},
						run: (*parser).callonComparisonExpression2,
						expr: &seqExpr{
							pos: position{line: 258, col: 25, offset: 7295},
							exprs: []any{
								&litMatcher{
									pos:        position{line: 258, col: 25, offset: 7295},
									val:        "(",
									ignoreCase: false,
									want:       "\"(\"",
								},
								&ruleRefExpr{
									pos:  position{line: 258, col: 29, offset: 7299},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 258, col: 32, offset: 7302},
									label: "ex",
									expr: &ruleRefExpr{
										pos:  position{line: 258, col: 35, offset: 7305},
										name: "OrExpression",
									},
								},
								&ruleRefExpr{
									pos:  position{line: 258, col: 48, offset: 7318},
									name: "ws",
								},
								&litMatcher{
									pos:        position{line: 258, col: 51, offset: 7321},
									val:        ")",
									ignoreCase: false,
									want:       "\")\"",
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 259, col: 7, offset: 7350},
						run: (*parser).callonComparisonExpression10,
						expr: &seqExpr{
							pos: position{line: 259, col: 7, offset: 7350},
							exprs: []any{
								&labeledExpr{
									pos:   position{line: 259, col: 7, offset: 7350},
									label: "left",
									expr: &ruleRefExpr{
										pos:  position{line: 259, col: 12, offset: 7355},
										name: "SelectItem",
									},
								},
								&ruleRefExpr{
									pos:  position{line: 259, col: 23, offset: 7366},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 259, col: 26, offset: 7369},
									label: "op",
									expr: &ruleRefExpr{
										pos:  position{line: 259, col: 29, offset: 7372},
										name: "ComparisonOperator",
									},
								},
								&ruleRefExpr{
									pos:  position{line: 259, col: 48, offset: 7391},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 259, col: 51, offset: 7394},
									label: "right",
									expr: &ruleRefExpr{
										pos:  position{line: 259, col: 57, offset: 7400},
										name: "SelectItem",
									},
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 261, col: 5, offset: 7507},
						run: (*parser).callonComparisonExpression20,
						expr: &labeledExpr{
							pos:   position{line: 261, col: 5, offset: 7507},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 261, col: 8, offset: 7510},
								name: "BooleanLiteral",
							},
						},
					},
					&actionExpr{
						pos: position{line: 262, col: 5, offset: 7548},
						run: (*parser).callonComparisonExpression23,
						expr: &labeledExpr{
							pos:   position{line: 262, col: 5, offset: 7548},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 262, col: 8, offset: 7551},
								name: "SelectItem",
							},
						},
					},
				},
			},
		},
		{
			name: "OrderByClause",
			pos:  position{line: 264, col: 1, offset: 7582},
			expr: &actionExpr{
				pos: position{line: 264, col: 18, offset: 7599},
				run: (*parser).callonOrderByClause1,
				expr: &seqExpr{
					pos: position{line: 264, col: 18, offset: 7599},
					exprs: []any{
						&ruleRefExpr{
							pos:  position{line: 264, col: 18, offset: 7599},
							name: "OrderBy",
						},
						&ruleRefExpr{
							pos:  position{line: 264, col: 26, offset: 7607},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 264, col: 29, offset: 7610},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 264, col: 33, offset: 7614},
								name: "OrderExpression",
							},
						},
						&labeledExpr{
							pos:   position{line: 264, col: 49, offset: 7630},
							label: "others",
							expr: &zeroOrMoreExpr{
								pos: position{line: 264, col: 56, offset: 7637},
								expr: &actionExpr{
									pos: position{line: 264, col: 57, offset: 7638},
									run: (*parser).callonOrderByClause9,
									expr: &seqExpr{
										pos: position{line: 264, col: 57, offset: 7638},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 264, col: 57, offset: 7638},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 264, col: 60, offset: 7641},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 264, col: 64, offset: 7645},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 264, col: 67, offset: 7648},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 264, col: 70, offset: 7651},
													name: "OrderExpression",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "OrderExpression",
			pos:  position{line: 268, col: 1, offset: 7735},
			expr: &actionExpr{
				pos: position{line: 268, col: 20, offset: 7754},
				run: (*parser).callonOrderExpression1,
				expr: &seqExpr{
					pos: position{line: 268, col: 20, offset: 7754},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 268, col: 20, offset: 7754},
							label: "field",
							expr: &ruleRefExpr{
								pos:  position{line: 268, col: 26, offset: 7760},
								name: "SelectProperty",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 268, col: 41, offset: 7775},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 268, col: 44, offset: 7778},
							label: "order",
							expr: &zeroOrOneExpr{
								pos: position{line: 268, col: 50, offset: 7784},
								expr: &ruleRefExpr{
									pos:  position{line: 268, col: 50, offset: 7784},
									name: "OrderDirection",
								},
							},
						},
					},
				},
			},
		},
		{
			name: "OrderDirection",
			pos:  position{line: 272, col: 1, offset: 7850},
			expr: &actionExpr{
				pos: position{line: 272, col: 19, offset: 7868},
				run: (*parser).callonOrderDirection1,
				expr: &choiceExpr{
					pos: position{line: 272, col: 20, offset: 7869},
					alternatives: []any{
						&litMatcher{
							pos:        position{line: 272, col: 20, offset: 7869},
							val:        "asc",
							ignoreCase: true,
							want:       "\"ASC\"i",
						},
						&litMatcher{
							pos:        position{line: 272, col: 29, offset: 7878},
							val:        "desc",
							ignoreCase: true,
							want:       "\"DESC\"i",
						},
					},
				},
			},
		},
		{
			name: "Select",
			pos:  position{line: 280, col: 1, offset: 8030},
			expr: &litMatcher{
				pos:        position{line: 280, col: 11, offset: 8040},
				val:        "select",
				ignoreCase: true,
				want:       "\"SELECT\"i",
			},
		},
		{
			name: "Top",
			pos:  position{line: 282, col: 1, offset: 8051},
			expr: &litMatcher{
				pos:        position{line: 282, col: 8, offset: 8058},
				val:        "top",
				ignoreCase: true,
				want:       "\"TOP\"i",
			},
		},
		{
			name: "As",
			pos:  position{line: 284, col: 1, offset: 8066},
			expr: &litMatcher{
				pos:        position{line: 284, col: 7, offset: 8072},
				val:        "as",
				ignoreCase: true,
				want:       "\"AS\"i",
			},
		},
		{
			name: "From",
			pos:  position{line: 286, col: 1, offset: 8079},
			expr: &litMatcher{
				pos:        position{line: 286, col: 9, offset: 8087},
				val:        "from",
				ignoreCase: true,
				want:       "\"FROM\"i",
			},
		},
		{
			name: "Where",
			pos:  position{line: 288, col: 1, offset: 8096},
			expr: &litMatcher{
				pos:        position{line: 288, col: 10, offset: 8105},
				val:        "where",
				ignoreCase: true,
				want:       "\"WHERE\"i",
			},
		},
		{
			name: "And",
			pos:  position{line: 290, col: 1, offset: 8115},
			expr: &litMatcher{
				pos:        position{line: 290, col: 8, offset: 8122},
				val:        "and",
				ignoreCase: true,
				want:       "\"AND\"i",
			},
		},
		{
			name: "Or",
			pos:  position{line: 292, col: 1, offset: 8130},
			expr: &litMatcher{
				pos:        position{line: 292, col: 7, offset: 8136},
				val:        "or",
				ignoreCase: true,
				want:       "\"OR\"i",
			},
		},
		{
			name: "GroupBy",
			pos:  position{line: 294, col: 1, offset: 8143},
			expr: &seqExpr{
				pos: position{line: 294, col: 12, offset: 8154},
				exprs: []any{
					&litMatcher{
						pos:        position{line: 294, col: 12, offset: 8154},
						val:        "group",
						ignoreCase: true,
						want:       "\"GROUP\"i",
					},
					&ruleRefExpr{
						pos:  position{line: 294, col: 21, offset: 8163},
						name: "ws",
					},
					&litMatcher{
						pos:        position{line: 294, col: 24, offset: 8166},
						val:        "by",
						ignoreCase: true,
						want:       "\"BY\"i",
					},
				},
			},
		},
		{
			name: "OrderBy",
			pos:  position{line: 296, col: 1, offset: 8173},
			expr: &seqExpr{
				pos: position{line: 296, col: 12, offset: 8184},
				exprs: []any{
					&litMatcher{
						pos:        position{line: 296, col: 12, offset: 8184},
						val:        "order",
						ignoreCase: true,
						want:       "\"ORDER\"i",
					},
					&ruleRefExpr{
						pos:  position{line: 296, col: 21, offset: 8193},
						name: "ws",
					},
					&litMatcher{
						pos:        position{line: 296, col: 24, offset: 8196},
						val:        "by",
						ignoreCase: true,
						want:       "\"BY\"i",
					},
				},
			},
		},
		{
			name: "ComparisonOperator",
			pos:  position{line: 298, col: 1, offset: 8203},
			expr: &actionExpr{
				pos: position{line: 298, col: 23, offset: 8225},
				run: (*parser).callonComparisonOperator1,
				expr: &choiceExpr{
					pos: position{line: 298, col: 24, offset: 8226},
					alternatives: []any{
						&litMatcher{
							pos:        position{line: 298, col: 24, offset: 8226},
							val:        "=",
							ignoreCase: false,
							want:       "\"=\"",
						},
						&litMatcher{
							pos:        position{line: 298, col: 30, offset: 8232},
							val:        "!=",
							ignoreCase: false,
							want:       "\"!=\"",
						},
						&litMatcher{
							pos:        position{line: 298, col: 37, offset: 8239},
							val:        "<",
							ignoreCase: false,
							want:       "\"<\"",
						},
						&litMatcher{
							pos:        position{line: 298, col: 43, offset: 8245},
							val:        "<=",
							ignoreCase: false,
							want:       "\"<=\"",
						},
						&litMatcher{
							pos:        position{line: 298, col: 50, offset: 8252},
							val:        ">",
							ignoreCase: false,
							want:       "\">\"",
						},
						&litMatcher{
							pos:        position{line: 298, col: 56, offset: 8258},
							val:        ">=",
							ignoreCase: false,
							want:       "\">=\"",
						},
					},
				},
			},
		},
		{
			name: "Literal",
			pos:  position{line: 302, col: 1, offset: 8300},
			expr: &choiceExpr{
				pos: position{line: 302, col: 12, offset: 8311},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 302, col: 12, offset: 8311},
						name: "FloatLiteral",
					},
					&ruleRefExpr{
						pos:  position{line: 302, col: 27, offset: 8326},
						name: "IntegerLiteral",
					},
					&ruleRefExpr{
						pos:  position{line: 302, col: 44, offset: 8343},
						name: "StringLiteral",
					},
					&ruleRefExpr{
						pos:  position{line: 302, col: 60, offset: 8359},
						name: "BooleanLiteral",
					},
					&ruleRefExpr{
						pos:  position{line: 302, col: 77, offset: 8376},
						name: "ParameterConstant",
					},
					&ruleRefExpr{
						pos:  position{line: 302, col: 97, offset: 8396},
						name: "NullConstant",
					},
				},
			},
		},
		{
			name: "ParameterConstant",
			pos:  position{line: 304, col: 1, offset: 8410},
			expr: &actionExpr{
				pos: position{line: 304, col: 22, offset: 8431},
				run: (*parser).callonParameterConstant1,
				expr: &seqExpr{
					pos: position{line: 304, col: 22, offset: 8431},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 304, col: 22, offset: 8431},
							val:        "@",
							ignoreCase: false,
							want:       "\"@\"",
						},
						&ruleRefExpr{
							pos:  position{line: 304, col: 26, offset: 8435},
							name: "Identifier",
						},
					},
				},
			},
		},
		{
			name: "NullConstant",
			pos:  position{line: 307, col: 1, offset: 8551},
			expr: &actionExpr{
				pos: position{line: 307, col: 17, offset: 8567},
				run: (*parser).callonNullConstant1,
				expr: &litMatcher{
					pos:        position{line: 307, col: 17, offset: 8567},
					val:        "null",
					ignoreCase: true,
					want:       "\"null\"i",
				},
			},
		},
		{
			name: "IntegerLiteral",
			pos:  position{line: 311, col: 1, offset: 8625},
			expr: &actionExpr{
				pos: position{line: 311, col: 19, offset: 8643},
				run: (*parser).callonIntegerLiteral1,
				expr: &labeledExpr{
					pos:   position{line: 311, col: 19, offset: 8643},
					label: "number",
					expr: &ruleRefExpr{
						pos:  position{line: 311, col: 26, offset: 8650},
						name: "Integer",
					},
				},
			},
		},
		{
			name: "StringLiteral",
			pos:  position{line: 314, col: 1, offset: 8751},
			expr: &actionExpr{
				pos: position{line: 314, col: 18, offset: 8768},
				run: (*parser).callonStringLiteral1,
				expr: &seqExpr{
					pos: position{line: 314, col: 18, offset: 8768},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 314, col: 18, offset: 8768},
							val:        "\"",
							ignoreCase: false,
							want:       "\"\\\"\"",
						},
						&labeledExpr{
							pos:   position{line: 314, col: 23, offset: 8773},
							label: "chars",
							expr: &zeroOrMoreExpr{
								pos: position{line: 314, col: 29, offset: 8779},
								expr: &ruleRefExpr{
									pos:  position{line: 314, col: 29, offset: 8779},
									name: "StringCharacter",
								},
							},
						},
						&litMatcher{
							pos:        position{line: 314, col: 46, offset: 8796},
							val:        "\"",
							ignoreCase: false,
							want:       "\"\\\"\"",
						},
					},
				},
			},
		},
		{
			name: "FloatLiteral",
			pos:  position{line: 317, col: 1, offset: 8914},
			expr: &actionExpr{
				pos: position{line: 317, col: 17, offset: 8930},
				run: (*parser).callonFloatLiteral1,
				expr: &seqExpr{
					pos: position{line: 317, col: 17, offset: 8930},
					exprs: []any{
						&oneOrMoreExpr{
							pos: position{line: 317, col: 17, offset: 8930},
							expr: &charClassMatcher{
								pos:        position{line: 317, col: 17, offset: 8930},
								val:        "[0-9]",
								ranges:     []rune{'0', '9'},
								ignoreCase: false,
								inverted:   false,
							},
						},
						&litMatcher{
							pos:        position{line: 317, col: 23, offset: 8936},
							val:        ".",
							ignoreCase: false,
							want:       "\".\"",
						},
						&oneOrMoreExpr{
							pos: position{line: 317, col: 26, offset: 8939},
							expr: &charClassMatcher{
								pos:        position{line: 317, col: 26, offset: 8939},
								val:        "[0-9]",
								ranges:     []rune{'0', '9'},
								ignoreCase: false,
								inverted:   false,
							},
						},
					},
				},
			},
		},
		{
			name: "BooleanLiteral",
			pos:  position{line: 321, col: 1, offset: 9095},
			expr: &actionExpr{
				pos: position{line: 321, col: 19, offset: 9113},
				run: (*parser).callonBooleanLiteral1,
				expr: &choiceExpr{
					pos: position{line: 321, col: 20, offset: 9114},
					alternatives: []any{
						&litMatcher{
							pos:        position{line: 321, col: 20, offset: 9114},
							val:        "true",
							ignoreCase: true,
							want:       "\"true\"i",
						},
						&litMatcher{
							pos:        position{line: 321, col: 30, offset: 9124},
							val:        "false",
							ignoreCase: true,
							want:       "\"false\"i",
						},
					},
				},
			},
		},
		{
			name: "FunctionCall",
			pos:  position{line: 326, col: 1, offset: 9279},
			expr: &choiceExpr{
				pos: position{line: 326, col: 17, offset: 9295},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 326, col: 17, offset: 9295},
						name: "StringFunctions",
					},
					&ruleRefExpr{
						pos:  position{line: 327, col: 7, offset: 9317},
						name: "TypeCheckingFunctions",
					},
					&ruleRefExpr{
						pos:  position{line: 328, col: 7, offset: 9345},
						name: "ArrayFunctions",
					},
					&ruleRefExpr{
						pos:  position{line: 329, col: 7, offset: 9366},
						name: "InFunction",
					},
				},
			},
		},
		{
			name: "StringFunctions",
			pos:  position{line: 331, col: 1, offset: 9378},
			expr: &choiceExpr{
				pos: position{line: 331, col: 20, offset: 9397},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 331, col: 20, offset: 9397},
						name: "StringEqualsExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 332, col: 7, offset: 9426},
						name: "ToStringExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 333, col: 7, offset: 9451},
						name: "ConcatExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 334, col: 7, offset: 9474},
						name: "ThreeArgumentStringFunctionExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 335, col: 7, offset: 9518},
						name: "UpperExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 336, col: 7, offset: 9540},
						name: "LowerExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 337, col: 7, offset: 9562},
						name: "LeftExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 338, col: 7, offset: 9583},
						name: "LengthExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 339, col: 7, offset: 9606},
						name: "LTrimExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 340, col: 7, offset: 9628},
						name: "ReplaceExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 341, col: 7, offset: 9652},
						name: "ReplicateExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 342, col: 7, offset: 9678},
						name: "ReverseExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 343, col: 7, offset: 9702},
						name: "RightExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 344, col: 7, offset: 9724},
						name: "RTrimExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 345, col: 7, offset: 9746},
						name: "SubstringExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 346, col: 7, offset: 9772},
						name: "TrimExpression",
					},
				},
			},
		},
		{
			name: "TypeCheckingFunctions",
			pos:  position{line: 348, col: 1, offset: 9788},
			expr: &choiceExpr{
				pos: position{line: 348, col: 26, offset: 9813},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 348, col: 26, offset: 9813},
						name: "IsDefined",
					},
					&ruleRefExpr{
						pos:  position{line: 349, col: 7, offset: 9829},
						name: "IsArray",
					},
					&ruleRefExpr{
						pos:  position{line: 350, col: 7, offset: 9843},
						name: "IsBool",
					},
					&ruleRefExpr{
						pos:  position{line: 351, col: 7, offset: 9856},
						name: "IsFiniteNumber",
					},
					&ruleRefExpr{
						pos:  position{line: 352, col: 7, offset: 9877},
						name: "IsInteger",
					},
					&ruleRefExpr{
						pos:  position{line: 353, col: 7, offset: 9893},
						name: "IsNull",
					},
					&ruleRefExpr{
						pos:  position{line: 354, col: 7, offset: 9906},
						name: "IsNumber",
					},
					&ruleRefExpr{
						pos:  position{line: 355, col: 7, offset: 9921},
						name: "IsObject",
					},
					&ruleRefExpr{
						pos:  position{line: 356, col: 7, offset: 9936},
						name: "IsPrimitive",
					},
					&ruleRefExpr{
						pos:  position{line: 357, col: 7, offset: 9954},
						name: "IsString",
					},
				},
			},
		},
		{
			name: "ArrayFunctions",
			pos:  position{line: 359, col: 1, offset: 9964},
			expr: &choiceExpr{
				pos: position{line: 359, col: 19, offset: 9982},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 359, col: 19, offset: 9982},
						name: "ArrayConcatExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 360, col: 7, offset: 10010},
						name: "ArrayLengthExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 361, col: 7, offset: 10038},
						name: "ArraySliceExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 362, col: 7, offset: 10065},
						name: "SetIntersectExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 363, col: 7, offset: 10094},
						name: "SetUnionExpression",
					},
				},
			},
		},
		{
			name: "UpperExpression",
			pos:  position{line: 365, col: 1, offset: 10114},
			expr: &actionExpr{
				pos: position{line: 365, col: 20, offset: 10133},
				run: (*parser).callonUpperExpression1,
				expr: &seqExpr{
					pos: position{line: 365, col: 20, offset: 10133},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 365, col: 20, offset: 10133},
							val:        "upper",
							ignoreCase: true,
							want:       "\"UPPER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 365, col: 29, offset: 10142},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 365, col: 32, offset: 10145},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&labeledExpr{
							pos:   position{line: 365, col: 36, offset: 10149},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 365, col: 39, offset: 10152},
								name: "SelectItem",
							},
						},
						&litMatcher{
							pos:        position{line: 365, col: 50, offset: 10163},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "LowerExpression",
			pos:  position{line: 369, col: 1, offset: 10248},
			expr: &actionExpr{
				pos: position{line: 369, col: 20, offset: 10267},
				run: (*parser).callonLowerExpression1,
				expr: &seqExpr{
					pos: position{line: 369, col: 20, offset: 10267},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 369, col: 20, offset: 10267},
							val:        "lower",
							ignoreCase: true,
							want:       "\"LOWER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 369, col: 29, offset: 10276},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 369, col: 32, offset: 10279},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&labeledExpr{
							pos:   position{line: 369, col: 36, offset: 10283},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 369, col: 39, offset: 10286},
								name: "SelectItem",
							},
						},
						&litMatcher{
							pos:        position{line: 369, col: 50, offset: 10297},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "StringEqualsExpression",
			pos:  position{line: 373, col: 1, offset: 10382},
			expr: &actionExpr{
				pos: position{line: 373, col: 27, offset: 10408},
				run: (*parser).callonStringEqualsExpression1,
				expr: &seqExpr{
					pos: position{line: 373, col: 27, offset: 10408},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 373, col: 27, offset: 10408},
							val:        "stringequals",
							ignoreCase: true,
							want:       "\"STRINGEQUALS\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 373, col: 43, offset: 10424},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 373, col: 46, offset: 10427},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 373, col: 50, offset: 10431},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 373, col: 53, offset: 10434},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 373, col: 57, offset: 10438},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 373, col: 68, offset: 10449},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 373, col: 71, offset: 10452},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 373, col: 75, offset: 10456},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 373, col: 78, offset: 10459},
							label: "ex2",
							expr: &ruleRefExpr{
								pos:  position{line: 373, col: 82, offset: 10463},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 373, col: 93, offset: 10474},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 373, col: 96, offset: 10477},
							label: "ignoreCase",
							expr: &zeroOrOneExpr{
								pos: position{line: 373, col: 107, offset: 10488},
								expr: &actionExpr{
									pos: position{line: 373, col: 108, offset: 10489},
									run: (*parser).callonStringEqualsExpression17,
									expr: &seqExpr{
										pos: position{line: 373, col: 108, offset: 10489},
										exprs: []any{
											&litMatcher{
												pos:        position{line: 373, col: 108, offset: 10489},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 373, col: 112, offset: 10493},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 373, col: 115, offset: 10496},
												label: "boolean",
												expr: &ruleRefExpr{
													pos:  position{line: 373, col: 123, offset: 10504},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&litMatcher{
							pos:        position{line: 373, col: 160, offset: 10541},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ToStringExpression",
			pos:  position{line: 377, col: 1, offset: 10651},
			expr: &actionExpr{
				pos: position{line: 377, col: 23, offset: 10673},
				run: (*parser).callonToStringExpression1,
				expr: &seqExpr{
					pos: position{line: 377, col: 23, offset: 10673},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 377, col: 23, offset: 10673},
							val:        "tostring",
							ignoreCase: true,
							want:       "\"TOSTRING\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 377, col: 35, offset: 10685},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 377, col: 38, offset: 10688},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 377, col: 42, offset: 10692},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 377, col: 45, offset: 10695},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 377, col: 48, offset: 10698},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 377, col: 59, offset: 10709},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 377, col: 62, offset: 10712},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ConcatExpression",
			pos:  position{line: 381, col: 1, offset: 10800},
			expr: &actionExpr{
				pos: position{line: 381, col: 21, offset: 10820},
				run: (*parser).callonConcatExpression1,
				expr: &seqExpr{
					pos: position{line: 381, col: 21, offset: 10820},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 381, col: 21, offset: 10820},
							val:        "concat",
							ignoreCase: true,
							want:       "\"CONCAT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 381, col: 31, offset: 10830},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 381, col: 34, offset: 10833},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 381, col: 38, offset: 10837},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 381, col: 41, offset: 10840},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 381, col: 45, offset: 10844},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 381, col: 56, offset: 10855},
							label: "others",
							expr: &oneOrMoreExpr{
								pos: position{line: 381, col: 63, offset: 10862},
								expr: &actionExpr{
									pos: position{line: 381, col: 64, offset: 10863},
									run: (*parser).callonConcatExpression11,
									expr: &seqExpr{
										pos: position{line: 381, col: 64, offset: 10863},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 381, col: 64, offset: 10863},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 381, col: 67, offset: 10866},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 381, col: 71, offset: 10870},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 381, col: 74, offset: 10873},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 381, col: 77, offset: 10876},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 381, col: 109, offset: 10908},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 381, col: 112, offset: 10911},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "LeftExpression",
			pos:  position{line: 386, col: 1, offset: 11060},
			expr: &actionExpr{
				pos: position{line: 386, col: 19, offset: 11078},
				run: (*parser).callonLeftExpression1,
				expr: &seqExpr{
					pos: position{line: 386, col: 19, offset: 11078},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 386, col: 19, offset: 11078},
							val:        "left",
							ignoreCase: true,
							want:       "\"LEFT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 386, col: 27, offset: 11086},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 386, col: 30, offset: 11089},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 386, col: 34, offset: 11093},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 386, col: 37, offset: 11096},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 386, col: 40, offset: 11099},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 386, col: 51, offset: 11110},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 386, col: 54, offset: 11113},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 386, col: 58, offset: 11117},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 386, col: 61, offset: 11120},
							label: "length",
							expr: &ruleRefExpr{
								pos:  position{line: 386, col: 68, offset: 11127},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 386, col: 79, offset: 11138},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 386, col: 82, offset: 11141},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "LengthExpression",
			pos:  position{line: 390, col: 1, offset: 11233},
			expr: &actionExpr{
				pos: position{line: 390, col: 21, offset: 11253},
				run: (*parser).callonLengthExpression1,
				expr: &seqExpr{
					pos: position{line: 390, col: 21, offset: 11253},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 390, col: 21, offset: 11253},
							val:        "length",
							ignoreCase: true,
							want:       "\"LENGTH\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 390, col: 31, offset: 11263},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 390, col: 34, offset: 11266},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 390, col: 38, offset: 11270},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 390, col: 41, offset: 11273},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 390, col: 44, offset: 11276},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 390, col: 55, offset: 11287},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 390, col: 58, offset: 11290},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "LTrimExpression",
			pos:  position{line: 394, col: 1, offset: 11376},
			expr: &actionExpr{
				pos: position{line: 394, col: 20, offset: 11395},
				run: (*parser).callonLTrimExpression1,
				expr: &seqExpr{
					pos: position{line: 394, col: 20, offset: 11395},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 394, col: 20, offset: 11395},
							val:        "ltrim",
							ignoreCase: true,
							want:       "\"LTRIM\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 394, col: 29, offset: 11404},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 394, col: 32, offset: 11407},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 394, col: 36, offset: 11411},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 394, col: 39, offset: 11414},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 394, col: 42, offset: 11417},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 394, col: 53, offset: 11428},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 394, col: 56, offset: 11431},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ReplaceExpression",
			pos:  position{line: 398, col: 1, offset: 11516},
			expr: &actionExpr{
				pos: position{line: 398, col: 22, offset: 11537},
				run: (*parser).callonReplaceExpression1,
				expr: &seqExpr{
					pos: position{line: 398, col: 22, offset: 11537},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 398, col: 22, offset: 11537},
							val:        "replace",
							ignoreCase: true,
							want:       "\"REPLACE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 398, col: 33, offset: 11548},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 398, col: 36, offset: 11551},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 398, col: 40, offset: 11555},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 398, col: 43, offset: 11558},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 398, col: 47, offset: 11562},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 398, col: 58, offset: 11573},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 398, col: 61, offset: 11576},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 398, col: 65, offset: 11580},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 398, col: 68, offset: 11583},
							label: "ex2",
							expr: &ruleRefExpr{
								pos:  position{line: 398, col: 72, offset: 11587},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 398, col: 83, offset: 11598},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 398, col: 86, offset: 11601},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 398, col: 90, offset: 11605},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 398, col: 93, offset: 11608},
							label: "ex3",
							expr: &ruleRefExpr{
								pos:  position{line: 398, col: 97, offset: 11612},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 398, col: 108, offset: 11623},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 398, col: 111, offset: 11626},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ReplicateExpression",
			pos:  position{line: 402, col: 1, offset: 11724},
			expr: &actionExpr{
				pos: position{line: 402, col: 24, offset: 11747},
				run: (*parser).callonReplicateExpression1,
				expr: &seqExpr{
					pos: position{line: 402, col: 24, offset: 11747},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 402, col: 24, offset: 11747},
							val:        "replicate",
							ignoreCase: true,
							want:       "\"REPLICATE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 402, col: 37, offset: 11760},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 402, col: 40, offset: 11763},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 402, col: 44, offset: 11767},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 402, col: 47, offset: 11770},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 402, col: 51, offset: 11774},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 402, col: 62, offset: 11785},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 402, col: 65, offset: 11788},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 402, col: 69, offset: 11792},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 402, col: 72, offset: 11795},
							label: "ex2",
							expr: &ruleRefExpr{
								pos:  position{line: 402, col: 76, offset: 11799},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 402, col: 87, offset: 11810},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 402, col: 90, offset: 11813},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ReverseExpression",
			pos:  position{line: 406, col: 1, offset: 11908},
			expr: &actionExpr{
				pos: position{line: 406, col: 22, offset: 11929},
				run: (*parser).callonReverseExpression1,
				expr: &seqExpr{
					pos: position{line: 406, col: 22, offset: 11929},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 406, col: 22, offset: 11929},
							val:        "reverse",
							ignoreCase: true,
							want:       "\"REVERSE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 406, col: 33, offset: 11940},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 406, col: 36, offset: 11943},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 406, col: 40, offset: 11947},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 406, col: 43, offset: 11950},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 406, col: 46, offset: 11953},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 406, col: 57, offset: 11964},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 406, col: 60, offset: 11967},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "RightExpression",
			pos:  position{line: 410, col: 1, offset: 12054},
			expr: &actionExpr{
				pos: position{line: 410, col: 20, offset: 12073},
				run: (*parser).callonRightExpression1,
				expr: &seqExpr{
					pos: position{line: 410, col: 20, offset: 12073},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 410, col: 20, offset: 12073},
							val:        "right",
							ignoreCase: true,
							want:       "\"RIGHT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 410, col: 29, offset: 12082},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 410, col: 32, offset: 12085},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 410, col: 36, offset: 12089},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 410, col: 39, offset: 12092},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 410, col: 42, offset: 12095},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 410, col: 53, offset: 12106},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 410, col: 56, offset: 12109},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 410, col: 60, offset: 12113},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 410, col: 63, offset: 12116},
							label: "length",
							expr: &ruleRefExpr{
								pos:  position{line: 410, col: 70, offset: 12123},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 410, col: 81, offset: 12134},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 410, col: 84, offset: 12137},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "RTrimExpression",
			pos:  position{line: 414, col: 1, offset: 12230},
			expr: &actionExpr{
				pos: position{line: 414, col: 20, offset: 12249},
				run: (*parser).callonRTrimExpression1,
				expr: &seqExpr{
					pos: position{line: 414, col: 20, offset: 12249},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 414, col: 20, offset: 12249},
							val:        "rtrim",
							ignoreCase: true,
							want:       "\"RTRIM\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 414, col: 29, offset: 12258},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 414, col: 32, offset: 12261},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 414, col: 36, offset: 12265},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 414, col: 39, offset: 12268},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 414, col: 42, offset: 12271},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 414, col: 53, offset: 12282},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 414, col: 56, offset: 12285},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "SubstringExpression",
			pos:  position{line: 418, col: 1, offset: 12370},
			expr: &actionExpr{
				pos: position{line: 418, col: 24, offset: 12393},
				run: (*parser).callonSubstringExpression1,
				expr: &seqExpr{
					pos: position{line: 418, col: 24, offset: 12393},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 418, col: 24, offset: 12393},
							val:        "substring",
							ignoreCase: true,
							want:       "\"SUBSTRING\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 418, col: 37, offset: 12406},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 418, col: 40, offset: 12409},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 418, col: 44, offset: 12413},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 418, col: 47, offset: 12416},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 418, col: 50, offset: 12419},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 418, col: 61, offset: 12430},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 418, col: 64, offset: 12433},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 418, col: 68, offset: 12437},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 418, col: 71, offset: 12440},
							label: "startPos",
							expr: &ruleRefExpr{
								pos:  position{line: 418, col: 80, offset: 12449},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 418, col: 91, offset: 12460},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 418, col: 94, offset: 12463},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 418, col: 98, offset: 12467},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 418, col: 101, offset: 12470},
							label: "length",
							expr: &ruleRefExpr{
								pos:  position{line: 418, col: 108, offset: 12477},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 418, col: 119, offset: 12488},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 418, col: 122, offset: 12491},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "TrimExpression",
			pos:  position{line: 422, col: 1, offset: 12598},
			expr: &actionExpr{
				pos: position{line: 422, col: 19, offset: 12616},
				run: (*parser).callonTrimExpression1,
				expr: &seqExpr{
					pos: position{line: 422, col: 19, offset: 12616},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 422, col: 19, offset: 12616},
							val:        "trim",
							ignoreCase: true,
							want:       "\"TRIM\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 422, col: 27, offset: 12624},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 422, col: 30, offset: 12627},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 422, col: 34, offset: 12631},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 422, col: 37, offset: 12634},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 422, col: 40, offset: 12637},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 422, col: 51, offset: 12648},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 422, col: 54, offset: 12651},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ThreeArgumentStringFunctionExpression",
			pos:  position{line: 426, col: 1, offset: 12735},
			expr: &actionExpr{
				pos: position{line: 426, col: 42, offset: 12776},
				run: (*parser).callonThreeArgumentStringFunctionExpression1,
				expr: &seqExpr{
					pos: position{line: 426, col: 42, offset: 12776},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 426, col: 42, offset: 12776},
							label: "function",
							expr: &ruleRefExpr{
								pos:  position{line: 426, col: 51, offset: 12785},
								name: "ThreeArgumentStringFunction",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 426, col: 79, offset: 12813},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 426, col: 82, offset: 12816},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 426, col: 86, offset: 12820},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 426, col: 89, offset: 12823},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 426, col: 93, offset: 12827},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 426, col: 104, offset: 12838},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 426, col: 107, offset: 12841},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 426, col: 111, offset: 12845},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 426, col: 114, offset: 12848},
							label: "ex2",
							expr: &ruleRefExpr{
								pos:  position{line: 426, col: 118, offset: 12852},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 426, col: 129, offset: 12863},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 426, col: 132, offset: 12866},
							label: "ignoreCase",
							expr: &zeroOrOneExpr{
								pos: position{line: 426, col: 143, offset: 12877},
								expr: &actionExpr{
									pos: position{line: 426, col: 144, offset: 12878},
									run: (*parser).callonThreeArgumentStringFunctionExpression18,
									expr: &seqExpr{
										pos: position{line: 426, col: 144, offset: 12878},
										exprs: []any{
											&litMatcher{
												pos:        position{line: 426, col: 144, offset: 12878},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 426, col: 148, offset: 12882},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 426, col: 151, offset: 12885},
												label: "boolean",
												expr: &ruleRefExpr{
													pos:  position{line: 426, col: 159, offset: 12893},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&litMatcher{
							pos:        position{line: 426, col: 196, offset: 12930},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ThreeArgumentStringFunction",
			pos:  position{line: 444, col: 1, offset: 13452},
			expr: &actionExpr{
				pos: position{line: 444, col: 32, offset: 13483},
				run: (*parser).callonThreeArgumentStringFunction1,
				expr: &choiceExpr{
					pos: position{line: 444, col: 33, offset: 13484},
					alternatives: []any{
						&litMatcher{
							pos:        position{line: 444, col: 33, offset: 13484},
							val:        "contains",
							ignoreCase: true,
							want:       "\"CONTAINS\"i",
						},
						&litMatcher{
							pos:        position{line: 444, col: 47, offset: 13498},
							val:        "endswith",
							ignoreCase: true,
							want:       "\"ENDSWITH\"i",
						},
						&litMatcher{
							pos:        position{line: 444, col: 61, offset: 13512},
							val:        "startswith",
							ignoreCase: true,
							want:       "\"STARTSWITH\"i",
						},
						&litMatcher{
							pos:        position{line: 444, col: 77, offset: 13528},
							val:        "index_of",
							ignoreCase: true,
							want:       "\"INDEX_OF\"i",
						},
					},
				},
			},
		},
		{
			name: "IsDefined",
			pos:  position{line: 448, col: 1, offset: 13577},
			expr: &actionExpr{
				pos: position{line: 448, col: 14, offset: 13590},
				run: (*parser).callonIsDefined1,
				expr: &seqExpr{
					pos: position{line: 448, col: 14, offset: 13590},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 448, col: 14, offset: 13590},
							val:        "is_defined",
							ignoreCase: true,
							want:       "\"IS_DEFINED\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 448, col: 28, offset: 13604},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 448, col: 31, offset: 13607},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 448, col: 35, offset: 13611},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 448, col: 38, offset: 13614},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 448, col: 41, offset: 13617},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 448, col: 52, offset: 13628},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 448, col: 55, offset: 13631},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsArray",
			pos:  position{line: 452, col: 1, offset: 13720},
			expr: &actionExpr{
				pos: position{line: 452, col: 12, offset: 13731},
				run: (*parser).callonIsArray1,
				expr: &seqExpr{
					pos: position{line: 452, col: 12, offset: 13731},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 452, col: 12, offset: 13731},
							val:        "is_array",
							ignoreCase: true,
							want:       "\"IS_ARRAY\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 452, col: 24, offset: 13743},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 452, col: 27, offset: 13746},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 452, col: 31, offset: 13750},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 452, col: 34, offset: 13753},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 452, col: 37, offset: 13756},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 452, col: 48, offset: 13767},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 452, col: 51, offset: 13770},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsBool",
			pos:  position{line: 456, col: 1, offset: 13857},
			expr: &actionExpr{
				pos: position{line: 456, col: 11, offset: 13867},
				run: (*parser).callonIsBool1,
				expr: &seqExpr{
					pos: position{line: 456, col: 11, offset: 13867},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 456, col: 11, offset: 13867},
							val:        "is_bool",
							ignoreCase: true,
							want:       "\"IS_BOOL\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 456, col: 22, offset: 13878},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 456, col: 25, offset: 13881},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 456, col: 29, offset: 13885},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 456, col: 32, offset: 13888},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 456, col: 35, offset: 13891},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 456, col: 46, offset: 13902},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 456, col: 49, offset: 13905},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsFiniteNumber",
			pos:  position{line: 460, col: 1, offset: 13991},
			expr: &actionExpr{
				pos: position{line: 460, col: 19, offset: 14009},
				run: (*parser).callonIsFiniteNumber1,
				expr: &seqExpr{
					pos: position{line: 460, col: 19, offset: 14009},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 460, col: 19, offset: 14009},
							val:        "is_finite_number",
							ignoreCase: true,
							want:       "\"IS_FINITE_NUMBER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 460, col: 39, offset: 14029},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 460, col: 42, offset: 14032},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 460, col: 46, offset: 14036},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 460, col: 49, offset: 14039},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 460, col: 52, offset: 14042},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 460, col: 63, offset: 14053},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 460, col: 66, offset: 14056},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsInteger",
			pos:  position{line: 464, col: 1, offset: 14150},
			expr: &actionExpr{
				pos: position{line: 464, col: 14, offset: 14163},
				run: (*parser).callonIsInteger1,
				expr: &seqExpr{
					pos: position{line: 464, col: 14, offset: 14163},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 464, col: 14, offset: 14163},
							val:        "is_integer",
							ignoreCase: true,
							want:       "\"IS_INTEGER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 464, col: 28, offset: 14177},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 464, col: 31, offset: 14180},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 464, col: 35, offset: 14184},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 464, col: 38, offset: 14187},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 464, col: 41, offset: 14190},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 464, col: 52, offset: 14201},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 464, col: 55, offset: 14204},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsNull",
			pos:  position{line: 468, col: 1, offset: 14293},
			expr: &actionExpr{
				pos: position{line: 468, col: 11, offset: 14303},
				run: (*parser).callonIsNull1,
				expr: &seqExpr{
					pos: position{line: 468, col: 11, offset: 14303},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 468, col: 11, offset: 14303},
							val:        "is_null",
							ignoreCase: true,
							want:       "\"IS_NULL\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 468, col: 22, offset: 14314},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 468, col: 25, offset: 14317},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 468, col: 29, offset: 14321},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 468, col: 32, offset: 14324},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 468, col: 35, offset: 14327},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 468, col: 46, offset: 14338},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 468, col: 49, offset: 14341},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsNumber",
			pos:  position{line: 472, col: 1, offset: 14427},
			expr: &actionExpr{
				pos: position{line: 472, col: 13, offset: 14439},
				run: (*parser).callonIsNumber1,
				expr: &seqExpr{
					pos: position{line: 472, col: 13, offset: 14439},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 472, col: 13, offset: 14439},
							val:        "is_number",
							ignoreCase: true,
							want:       "\"IS_NUMBER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 472, col: 26, offset: 14452},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 472, col: 29, offset: 14455},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 472, col: 33, offset: 14459},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 472, col: 36, offset: 14462},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 472, col: 39, offset: 14465},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 472, col: 50, offset: 14476},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 472, col: 53, offset: 14479},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsObject",
			pos:  position{line: 476, col: 1, offset: 14567},
			expr: &actionExpr{
				pos: position{line: 476, col: 13, offset: 14579},
				run: (*parser).callonIsObject1,
				expr: &seqExpr{
					pos: position{line: 476, col: 13, offset: 14579},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 476, col: 13, offset: 14579},
							val:        "is_object",
							ignoreCase: true,
							want:       "\"IS_OBJECT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 476, col: 26, offset: 14592},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 476, col: 29, offset: 14595},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 476, col: 33, offset: 14599},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 476, col: 36, offset: 14602},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 476, col: 39, offset: 14605},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 476, col: 50, offset: 14616},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 476, col: 53, offset: 14619},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsPrimitive",
			pos:  position{line: 480, col: 1, offset: 14707},
			expr: &actionExpr{
				pos: position{line: 480, col: 16, offset: 14722},
				run: (*parser).callonIsPrimitive1,
				expr: &seqExpr{
					pos: position{line: 480, col: 16, offset: 14722},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 480, col: 16, offset: 14722},
							val:        "is_primitive",
							ignoreCase: true,
							want:       "\"IS_PRIMITIVE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 480, col: 32, offset: 14738},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 480, col: 35, offset: 14741},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 480, col: 39, offset: 14745},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 480, col: 42, offset: 14748},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 480, col: 45, offset: 14751},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 480, col: 56, offset: 14762},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 480, col: 59, offset: 14765},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsString",
			pos:  position{line: 484, col: 1, offset: 14856},
			expr: &actionExpr{
				pos: position{line: 484, col: 13, offset: 14868},
				run: (*parser).callonIsString1,
				expr: &seqExpr{
					pos: position{line: 484, col: 13, offset: 14868},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 484, col: 13, offset: 14868},
							val:        "is_string",
							ignoreCase: true,
							want:       "\"IS_STRING\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 484, col: 26, offset: 14881},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 484, col: 29, offset: 14884},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 484, col: 33, offset: 14888},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 484, col: 36, offset: 14891},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 484, col: 39, offset: 14894},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 484, col: 50, offset: 14905},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 484, col: 53, offset: 14908},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ArrayConcatExpression",
			pos:  position{line: 488, col: 1, offset: 14996},
			expr: &actionExpr{
				pos: position{line: 488, col: 26, offset: 15021},
				run: (*parser).callonArrayConcatExpression1,
				expr: &seqExpr{
					pos: position{line: 488, col: 26, offset: 15021},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 488, col: 26, offset: 15021},
							val:        "array_concat",
							ignoreCase: true,
							want:       "\"ARRAY_CONCAT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 488, col: 42, offset: 15037},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 488, col: 45, offset: 15040},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 488, col: 49, offset: 15044},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 488, col: 52, offset: 15047},
							label: "arrays",
							expr: &ruleRefExpr{
								pos:  position{line: 488, col: 59, offset: 15054},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 488, col: 70, offset: 15065},
							label: "others",
							expr: &oneOrMoreExpr{
								pos: position{line: 488, col: 77, offset: 15072},
								expr: &actionExpr{
									pos: position{line: 488, col: 78, offset: 15073},
									run: (*parser).callonArrayConcatExpression11,
									expr: &seqExpr{
										pos: position{line: 488, col: 78, offset: 15073},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 488, col: 78, offset: 15073},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 488, col: 81, offset: 15076},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 488, col: 85, offset: 15080},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 488, col: 88, offset: 15083},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 488, col: 91, offset: 15086},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 488, col: 123, offset: 15118},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 488, col: 126, offset: 15121},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ArrayLengthExpression",
			pos:  position{line: 492, col: 1, offset: 15251},
			expr: &actionExpr{
				pos: position{line: 492, col: 26, offset: 15276},
				run: (*parser).callonArrayLengthExpression1,
				expr: &seqExpr{
					pos: position{line: 492, col: 26, offset: 15276},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 492, col: 26, offset: 15276},
							val:        "array_length",
							ignoreCase: true,
							want:       "\"ARRAY_LENGTH\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 492, col: 42, offset: 15292},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 492, col: 45, offset: 15295},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 492, col: 49, offset: 15299},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 492, col: 52, offset: 15302},
							label: "array",
							expr: &ruleRefExpr{
								pos:  position{line: 492, col: 58, offset: 15308},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 492, col: 69, offset: 15319},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 492, col: 72, offset: 15322},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ArraySliceExpression",
			pos:  position{line: 496, col: 1, offset: 15416},
			expr: &actionExpr{
				pos: position{line: 496, col: 25, offset: 15440},
				run: (*parser).callonArraySliceExpression1,
				expr: &seqExpr{
					pos: position{line: 496, col: 25, offset: 15440},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 496, col: 25, offset: 15440},
							val:        "array_slice",
							ignoreCase: true,
							want:       "\"ARRAY_SLICE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 496, col: 40, offset: 15455},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 496, col: 43, offset: 15458},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 496, col: 47, offset: 15462},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 496, col: 50, offset: 15465},
							label: "array",
							expr: &ruleRefExpr{
								pos:  position{line: 496, col: 56, offset: 15471},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 496, col: 67, offset: 15482},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 496, col: 70, offset: 15485},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 496, col: 74, offset: 15489},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 496, col: 77, offset: 15492},
							label: "start",
							expr: &ruleRefExpr{
								pos:  position{line: 496, col: 83, offset: 15498},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 496, col: 94, offset: 15509},
							label: "length",
							expr: &zeroOrOneExpr{
								pos: position{line: 496, col: 101, offset: 15516},
								expr: &actionExpr{
									pos: position{line: 496, col: 102, offset: 15517},
									run: (*parser).callonArraySliceExpression16,
									expr: &seqExpr{
										pos: position{line: 496, col: 102, offset: 15517},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 496, col: 102, offset: 15517},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 496, col: 105, offset: 15520},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 496, col: 109, offset: 15524},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 496, col: 112, offset: 15527},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 496, col: 115, offset: 15530},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 496, col: 147, offset: 15562},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 496, col: 150, offset: 15565},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "SetIntersectExpression",
			pos:  position{line: 500, col: 1, offset: 15673},
			expr: &actionExpr{
				pos: position{line: 500, col: 27, offset: 15699},
				run: (*parser).callonSetIntersectExpression1,
				expr: &seqExpr{
					pos: position{line: 500, col: 27, offset: 15699},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 500, col: 27, offset: 15699},
							val:        "setintersect",
							ignoreCase: true,
							want:       "\"SetIntersect\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 500, col: 43, offset: 15715},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 500, col: 46, offset: 15718},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 500, col: 50, offset: 15722},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 500, col: 53, offset: 15725},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 500, col: 58, offset: 15730},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 500, col: 69, offset: 15741},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 500, col: 72, offset: 15744},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 500, col: 76, offset: 15748},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 500, col: 79, offset: 15751},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 500, col: 84, offset: 15756},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 500, col: 95, offset: 15767},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 500, col: 98, offset: 15770},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "SetUnionExpression",
			pos:  position{line: 504, col: 1, offset: 15870},
			expr: &actionExpr{
				pos: position{line: 504, col: 23, offset: 15892},
				run: (*parser).callonSetUnionExpression1,
				expr: &seqExpr{
					pos: position{line: 504, col: 23, offset: 15892},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 504, col: 23, offset: 15892},
							val:        "setunion",
							ignoreCase: true,
							want:       "\"SetUnion\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 504, col: 35, offset: 15904},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 504, col: 38, offset: 15907},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 504, col: 42, offset: 15911},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 504, col: 45, offset: 15914},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 504, col: 50, offset: 15919},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 504, col: 61, offset: 15930},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 504, col: 64, offset: 15933},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 504, col: 68, offset: 15937},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 504, col: 71, offset: 15940},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 504, col: 76, offset: 15945},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 504, col: 87, offset: 15956},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 504, col: 90, offset: 15959},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "InFunction",
			pos:  position{line: 508, col: 1, offset: 16055},
			expr: &actionExpr{
				pos: position{line: 508, col: 15, offset: 16069},
				run: (*parser).callonInFunction1,
				expr: &seqExpr{
					pos: position{line: 508, col: 15, offset: 16069},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 508, col: 15, offset: 16069},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 508, col: 19, offset: 16073},
								name: "SelectProperty",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 508, col: 34, offset: 16088},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 508, col: 37, offset: 16091},
							val:        "in",
							ignoreCase: true,
							want:       "\"IN\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 508, col: 43, offset: 16097},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 508, col: 46, offset: 16100},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 508, col: 50, offset: 16104},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 508, col: 53, offset: 16107},
							label: "ex2",
							expr: &ruleRefExpr{
								pos:  position{line: 508, col: 57, offset: 16111},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 508, col: 68, offset: 16122},
							label: "others",
							expr: &zeroOrMoreExpr{
								pos: position{line: 508, col: 75, offset: 16129},
								expr: &actionExpr{
									pos: position{line: 508, col: 76, offset: 16130},
									run: (*parser).callonInFunction14,
									expr: &seqExpr{
										pos: position{line: 508, col: 76, offset: 16130},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 508, col: 76, offset: 16130},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 508, col: 79, offset: 16133},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 508, col: 83, offset: 16137},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 508, col: 86, offset: 16140},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 508, col: 89, offset: 16143},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 508, col: 121, offset: 16175},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 508, col: 124, offset: 16178},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "Integer",
			pos:  position{line: 512, col: 1, offset: 16301},
			expr: &actionExpr{
				pos: position{line: 512, col: 12, offset: 16312},
				run: (*parser).callonInteger1,
				expr: &oneOrMoreExpr{
					pos: position{line: 512, col: 12, offset: 16312},
					expr: &charClassMatcher{
						pos:        position{line: 512, col: 12, offset: 16312},
						val:        "[0-9]",
						ranges:     []rune{'0', '9'},
						ignoreCase: false,
						inverted:   false,
					},
				},
			},
		},
		{
			name: "StringCharacter",
			pos:  position{line: 516, col: 1, offset: 16364},
			expr: &choiceExpr{
				pos: position{line: 516, col: 20, offset: 16383},
				alternatives: []any{
					&actionExpr{
						pos: position{line: 516, col: 20, offset: 16383},
						run: (*parser).callonStringCharacter2,
						expr: &seqExpr{
							pos: position{line: 516, col: 20, offset: 16383},
							exprs: []any{
								&notExpr{
									pos: position{line: 516, col: 20, offset: 16383},
									expr: &choiceExpr{
										pos: position{line: 516, col: 22, offset: 16385},
										alternatives: []any{
											&litMatcher{
												pos:        position{line: 516, col: 22, offset: 16385},
												val:        "\"",
												ignoreCase: false,
												want:       "\"\\\"\"",
											},
											&litMatcher{
												pos:        position{line: 516, col: 28, offset: 16391},
												val:        "\\",
												ignoreCase: false,
												want:       "\"\\\\\"",
											},
										},
									},
								},
								&anyMatcher{
									line: 516, col: 34, offset: 16397,
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 517, col: 5, offset: 16434},
						run: (*parser).callonStringCharacter9,
						expr: &seqExpr{
							pos: position{line: 517, col: 5, offset: 16434},
							exprs: []any{
								&litMatcher{
									pos:        position{line: 517, col: 5, offset: 16434},
									val:        "\\",
									ignoreCase: false,
									want:       "\"\\\\\"",
								},
								&labeledExpr{
									pos:   position{line: 517, col: 10, offset: 16439},
									label: "seq",
									expr: &ruleRefExpr{
										pos:  position{line: 517, col: 14, offset: 16443},
										name: "EscapeSequenceCharacter",
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "EscapeSequenceCharacter",
			pos:  position{line: 519, col: 1, offset: 16488},
			expr: &labeledExpr{
				pos:   position{line: 519, col: 28, offset: 16515},
				label: "char",
				expr: &ruleRefExpr{
					pos:  position{line: 519, col: 33, offset: 16520},
					name: "EscapeCharacter",
				},
			},
		},
		{
			name: "EscapeCharacter",
			pos:  position{line: 521, col: 1, offset: 16537},
			expr: &choiceExpr{
				pos: position{line: 521, col: 20, offset: 16556},
				alternatives: []any{
					&litMatcher{
						pos:        position{line: 521, col: 20, offset: 16556},
						val:        "'",
						ignoreCase: false,
						want:       "\"'\"",
					},
					&litMatcher{
						pos:        position{line: 522, col: 5, offset: 16564},
						val:        "\"",
						ignoreCase: false,
						want:       "\"\\\"\"",
					},
					&litMatcher{
						pos:        position{line: 523, col: 5, offset: 16572},
						val:        "\\",
						ignoreCase: false,
						want:       "\"\\\\\"",
					},
					&actionExpr{
						pos: position{line: 524, col: 5, offset: 16581},
						run: (*parser).callonEscapeCharacter5,
						expr: &litMatcher{
							pos:        position{line: 524, col: 5, offset: 16581},
							val:        "b",
							ignoreCase: false,
							want:       "\"b\"",
						},
					},
					&actionExpr{
						pos: position{line: 525, col: 5, offset: 16610},
						run: (*parser).callonEscapeCharacter7,
						expr: &litMatcher{
							pos:        position{line: 525, col: 5, offset: 16610},
							val:        "f",
							ignoreCase: false,
							want:       "\"f\"",
						},
					},
					&actionExpr{
						pos: position{line: 526, col: 5, offset: 16639},
						run: (*parser).callonEscapeCharacter9,
						expr: &litMatcher{
							pos:        position{line: 526, col: 5, offset: 16639},
							val:        "n",
							ignoreCase: false,
							want:       "\"n\"",
						},
					},
					&actionExpr{
						pos: position{line: 527, col: 5, offset: 16668},
						run: (*parser).callonEscapeCharacter11,
						expr: &litMatcher{
							pos:        position{line: 527, col: 5, offset: 16668},
							val:        "r",
							ignoreCase: false,
							want:       "\"r\"",
						},
					},
					&actionExpr{
						pos: position{line: 528, col: 5, offset: 16697},
						run: (*parser).callonEscapeCharacter13,
						expr: &litMatcher{
							pos:        position{line: 528, col: 5, offset: 16697},
							val:        "t",
							ignoreCase: false,
							want:       "\"t\"",
						},
					},
				},
			},
		},
		{
			name: "non_escape_character",
			pos:  position{line: 530, col: 1, offset: 16723},
			expr: &actionExpr{
				pos: position{line: 530, col: 25, offset: 16747},
				run: (*parser).callonnon_escape_character1,
				expr: &seqExpr{
					pos: position{line: 530, col: 25, offset: 16747},
					exprs: []any{
						&notExpr{
							pos: position{line: 530, col: 25, offset: 16747},
							expr: &ruleRefExpr{
								pos:  position{line: 530, col: 27, offset: 16749},
								name: "escape_character",
							},
						},
						&labeledExpr{
							pos:   position{line: 530, col: 45, offset: 16767},
							label: "char",
							expr: &anyMatcher{
								line: 530, col: 50, offset: 16772,
							},
						},
					},
				},
			},
		},
		{
			name: "ws",
			pos:  position{line: 533, col: 1, offset: 16811},
			expr: &zeroOrMoreExpr{
				pos: position{line: 533, col: 7, offset: 16817},
				expr: &charClassMatcher{
					pos:        position{line: 533, col: 7, offset: 16817},
					val:        "[ \\t\\n\\r]",
					chars:      []rune{' ', '\t', '\n', '\r'},
					ignoreCase: false,
					inverted:   false,
				},
			},
		},
		{
			name: "EOF",
			pos:  position{line: 535, col: 1, offset: 16829},
			expr: &notExpr{
				pos: position{line: 535, col: 8, offset: 16836},
				expr: &anyMatcher{
					line: 535, col: 9, offset: 16837,
				},
			},
		},
	},
}

func (c *current) onInput1(selectStmt any) (any, error) {
	return selectStmt, nil
}

func (p *parser) callonInput1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInput1(stack["selectStmt"])
}

func (c *current) onSelectStmt23(condition any) (any, error) {
	return condition, nil
}

func (p *parser) callonSelectStmt23() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectStmt23(stack["condition"])
}

func (c *current) onSelectStmt32(columns any) (any, error) {
	return columns, nil
}

func (p *parser) callonSelectStmt32() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectStmt32(stack["columns"])
}

func (c *current) onSelectStmt1(distinctClause, topClause, columns, table, whereClause, groupByClause, orderByClause any) (any, error) {
	return makeSelectStmt(columns, table, whereClause,
		distinctClause, topClause, groupByClause, orderByClause)
}

func (p *parser) callonSelectStmt1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectStmt1(stack["distinctClause"], stack["topClause"], stack["columns"], stack["table"], stack["whereClause"], stack["groupByClause"], stack["orderByClause"])
}

func (c *current) onTopClause1(count any) (any, error) {
	return count, nil
}

func (p *parser) callonTopClause1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onTopClause1(stack["count"])
}

func (c *current) onSelectAsterisk1() (any, error) {
	selectItem, _ := makeSelectItem("c", make([]interface{}, 0), parsers.SelectItemTypeField)
	selectItem.IsTopLevel = true
	return makeColumnList(selectItem, make([]interface{}, 0))
}

func (p *parser) callonSelectAsterisk1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectAsterisk1()
}

func (c *current) onColumnList7(coll any) (any, error) {
	return coll, nil
}

func (p *parser) callonColumnList7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onColumnList7(stack["coll"])
}

func (c *current) onColumnList1(column, other_columns any) (any, error) {
	return makeColumnList(column, other_columns)
}

func (p *parser) callonColumnList1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onColumnList1(stack["column"], stack["other_columns"])
}

func (c *current) onSelectValueSpec1(column any) (any, error) {
	selectItem := column.(parsers.SelectItem)
	selectItem.IsTopLevel = true
	return makeColumnList(selectItem, make([]interface{}, 0))
}

func (p *parser) callonSelectValueSpec1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectValueSpec1(stack["column"])
}

func (c *current) onTableName1(key any) (any, error) {
	return parsers.Table{Value: key.(string)}, nil
}

func (p *parser) callonTableName1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onTableName1(stack["key"])
}

func (c *current) onSelectArray1(columns any) (any, error) {
	return makeSelectArray(columns)
}

func (p *parser) callonSelectArray1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectArray1(stack["columns"])
}

func (c *current) onSelectObject10(coll any) (any, error) {
	return coll, nil
}

func (p *parser) callonSelectObject10() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectObject10(stack["coll"])
}

func (c *current) onSelectObject1(field, other_fields any) (any, error) {
	return makeSelectObject(field, other_fields)
}

func (p *parser) callonSelectObject1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectObject1(stack["field"], stack["other_fields"])
}

func (c *current) onSelectObjectField6(key any) (any, error) {
	return key, nil
}

func (p *parser) callonSelectObjectField6() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectObjectField6(stack["key"])
}

func (c *current) onSelectObjectField1(name, selectItem any) (any, error) {
	item := selectItem.(parsers.SelectItem)
	item.Alias = name.(string)
	return item, nil
}

func (p *parser) callonSelectObjectField1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectObjectField1(stack["name"], stack["selectItem"])
}

func (c *current) onSelectProperty1(name, path any) (any, error) {
	return makeSelectItem(name, path, parsers.SelectItemTypeField)
}

func (p *parser) callonSelectProperty1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectProperty1(stack["name"], stack["path"])
}

func (c *current) onSelectItem1(selectItem, asClause any) (any, error) {
	var itemResult parsers.SelectItem
	switch typedValue := selectItem.(type) {
	case parsers.SelectItem:
		itemResult = typedValue
	case parsers.Constant:
		itemResult = parsers.SelectItem{
			Type:  parsers.SelectItemTypeConstant,
			Value: typedValue,
		}
	case parsers.FunctionCall:
		itemResult = parsers.SelectItem{
			Type:  parsers.SelectItemTypeFunctionCall,
			Value: typedValue,
		}
	}

	if aliasValue, ok := asClause.(string); ok {
		itemResult.Alias = aliasValue
	}

	return itemResult, nil
}

func (p *parser) callonSelectItem1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectItem1(stack["selectItem"], stack["asClause"])
}

func (c *current) onAsClause1(alias any) (any, error) {
	return alias, nil
}

func (p *parser) callonAsClause1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onAsClause1(stack["alias"])
}

func (c *current) onDotFieldAccess1(id any) (any, error) {
	return id, nil
}

func (p *parser) callonDotFieldAccess1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onDotFieldAccess1(stack["id"])
}

func (c *current) onArrayFieldAccess1(id any) (any, error) {
	return id, nil
}

func (p *parser) callonArrayFieldAccess1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayFieldAccess1(stack["id"])
}

func (c *current) onIdentifier1() (any, error) {
	return string(c.text), nil
}

func (p *parser) callonIdentifier1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIdentifier1()
}

func (c *current) onCondition1(expression any) (any, error) {
	return expression, nil
}

func (p *parser) callonCondition1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onCondition1(stack["expression"])
}

func (c *current) onOrExpression7(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonOrExpression7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrExpression7(stack["ex"])
}

func (c *current) onOrExpression1(ex1, ex2 any) (any, error) {
	return combineExpressions(ex1, ex2, parsers.LogicalExpressionTypeOr)
}

func (p *parser) callonOrExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrExpression1(stack["ex1"], stack["ex2"])
}

func (c *current) onAndExpression7(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonAndExpression7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onAndExpression7(stack["ex"])
}

func (c *current) onAndExpression1(ex1, ex2 any) (any, error) {
	return combineExpressions(ex1, ex2, parsers.LogicalExpressionTypeAnd)
}

func (p *parser) callonAndExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onAndExpression1(stack["ex1"], stack["ex2"])
}

func (c *current) onComparisonExpression2(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonComparisonExpression2() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonExpression2(stack["ex"])
}

func (c *current) onComparisonExpression10(left, op, right any) (any, error) {
	return parsers.ComparisonExpression{Left: left, Right: right, Operation: op.(string)}, nil
}

func (p *parser) callonComparisonExpression10() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonExpression10(stack["left"], stack["op"], stack["right"])
}

func (c *current) onComparisonExpression20(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonComparisonExpression20() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonExpression20(stack["ex"])
}

func (c *current) onComparisonExpression23(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonComparisonExpression23() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonExpression23(stack["ex"])
}

func (c *current) onOrderByClause9(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonOrderByClause9() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrderByClause9(stack["ex"])
}

func (c *current) onOrderByClause1(ex1, others any) (any, error) {
	return makeOrderByClause(ex1, others)
}

func (p *parser) callonOrderByClause1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrderByClause1(stack["ex1"], stack["others"])
}

func (c *current) onOrderExpression1(field, order any) (any, error) {
	return makeOrderExpression(field, order)
}

func (p *parser) callonOrderExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrderExpression1(stack["field"], stack["order"])
}

func (c *current) onOrderDirection1() (any, error) {
	if strings.EqualFold(string(c.text), "DESC") {
		return parsers.OrderDirectionDesc, nil
	}

	return parsers.OrderDirectionAsc, nil
}

func (p *parser) callonOrderDirection1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrderDirection1()
}

func (c *current) onComparisonOperator1() (any, error) {
	return string(c.text), nil
}

func (p *parser) callonComparisonOperator1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonOperator1()
}

func (c *current) onParameterConstant1() (any, error) {
	return parsers.Constant{Type: parsers.ConstantTypeParameterConstant, Value: string(c.text)}, nil
}

func (p *parser) callonParameterConstant1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onParameterConstant1()
}

func (c *current) onNullConstant1() (any, error) {
	return parsers.Constant{Value: nil}, nil
}

func (p *parser) callonNullConstant1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onNullConstant1()
}

func (c *current) onIntegerLiteral1(number any) (any, error) {
	return parsers.Constant{Type: parsers.ConstantTypeInteger, Value: number.(int)}, nil
}

func (p *parser) callonIntegerLiteral1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIntegerLiteral1(stack["number"])
}

func (c *current) onStringLiteral1(chars any) (any, error) {
	return parsers.Constant{Type: parsers.ConstantTypeString, Value: joinStrings(chars.([]interface{}))}, nil
}

func (p *parser) callonStringLiteral1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringLiteral1(stack["chars"])
}

func (c *current) onFloatLiteral1() (any, error) {
	floatValue, _ := strconv.ParseFloat(string(c.text), 64)
	return parsers.Constant{Type: parsers.ConstantTypeFloat, Value: floatValue}, nil
}

func (p *parser) callonFloatLiteral1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onFloatLiteral1()
}

func (c *current) onBooleanLiteral1() (any, error) {
	boolValue, _ := strconv.ParseBool(string(c.text))
	return parsers.Constant{Type: parsers.ConstantTypeBoolean, Value: boolValue}, nil
}

func (p *parser) callonBooleanLiteral1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onBooleanLiteral1()
}

func (c *current) onUpperExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallUpper, []interface{}{ex})
}

func (p *parser) callonUpperExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onUpperExpression1(stack["ex"])
}

func (c *current) onLowerExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallLower, []interface{}{ex})
}

func (p *parser) callonLowerExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onLowerExpression1(stack["ex"])
}

func (c *current) onStringEqualsExpression17(boolean any) (any, error) {
	return boolean, nil
}

func (p *parser) callonStringEqualsExpression17() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringEqualsExpression17(stack["boolean"])
}

func (c *current) onStringEqualsExpression1(ex1, ex2, ignoreCase any) (any, error) {
	return createFunctionCall(parsers.FunctionCallStringEquals, []interface{}{ex1, ex2, ignoreCase})
}

func (p *parser) callonStringEqualsExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringEqualsExpression1(stack["ex1"], stack["ex2"], stack["ignoreCase"])
}

func (c *current) onToStringExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallToString, []interface{}{ex})
}

func (p *parser) callonToStringExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onToStringExpression1(stack["ex"])
}

func (c *current) onConcatExpression11(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonConcatExpression11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onConcatExpression11(stack["ex"])
}

func (c *current) onConcatExpression1(ex1, others any) (any, error) {
	arguments := append([]interface{}{ex1}, others.([]interface{})...)
	return createFunctionCall(parsers.FunctionCallConcat, arguments)
}

func (p *parser) callonConcatExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onConcatExpression1(stack["ex1"], stack["others"])
}

func (c *current) onLeftExpression1(ex, length any) (any, error) {
	return createFunctionCall(parsers.FunctionCallLeft, []interface{}{ex, length})
}

func (p *parser) callonLeftExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onLeftExpression1(stack["ex"], stack["length"])
}

func (c *current) onLengthExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallLength, []interface{}{ex})
}

func (p *parser) callonLengthExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onLengthExpression1(stack["ex"])
}

func (c *current) onLTrimExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallLTrim, []interface{}{ex})
}

func (p *parser) callonLTrimExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onLTrimExpression1(stack["ex"])
}

func (c *current) onReplaceExpression1(ex1, ex2, ex3 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallReplace, []interface{}{ex1, ex2, ex3})
}

func (p *parser) callonReplaceExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onReplaceExpression1(stack["ex1"], stack["ex2"], stack["ex3"])
}

func (c *current) onReplicateExpression1(ex1, ex2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallReplicate, []interface{}{ex1, ex2})
}

func (p *parser) callonReplicateExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onReplicateExpression1(stack["ex1"], stack["ex2"])
}

func (c *current) onReverseExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallReverse, []interface{}{ex})
}

func (p *parser) callonReverseExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onReverseExpression1(stack["ex"])
}

func (c *current) onRightExpression1(ex, length any) (any, error) {
	return createFunctionCall(parsers.FunctionCallRight, []interface{}{ex, length})
}

func (p *parser) callonRightExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onRightExpression1(stack["ex"], stack["length"])
}

func (c *current) onRTrimExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallRTrim, []interface{}{ex})
}

func (p *parser) callonRTrimExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onRTrimExpression1(stack["ex"])
}

func (c *current) onSubstringExpression1(ex, startPos, length any) (any, error) {
	return createFunctionCall(parsers.FunctionCallSubstring, []interface{}{ex, startPos, length})
}

func (p *parser) callonSubstringExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSubstringExpression1(stack["ex"], stack["startPos"], stack["length"])
}

func (c *current) onTrimExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallTrim, []interface{}{ex})
}

func (p *parser) callonTrimExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onTrimExpression1(stack["ex"])
}

func (c *current) onThreeArgumentStringFunctionExpression18(boolean any) (any, error) {
	return boolean, nil
}

func (p *parser) callonThreeArgumentStringFunctionExpression18() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onThreeArgumentStringFunctionExpression18(stack["boolean"])
}

func (c *current) onThreeArgumentStringFunctionExpression1(function, ex1, ex2, ignoreCase any) (any, error) {
	var functionType parsers.FunctionCallType

	lowerFunction := strings.ToUpper(function.(string))
	switch lowerFunction {
	case "CONTAINS":
		functionType = parsers.FunctionCallContains
	case "ENDSWITH":
		functionType = parsers.FunctionCallEndsWith
	case "STARTSWITH":
		functionType = parsers.FunctionCallStartsWith
	case "INDEX_OF":
		functionType = parsers.FunctionCallIndexOf
	}

	return createFunctionCall(functionType, []interface{}{ex1, ex2, ignoreCase})
}

func (p *parser) callonThreeArgumentStringFunctionExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onThreeArgumentStringFunctionExpression1(stack["function"], stack["ex1"], stack["ex2"], stack["ignoreCase"])
}

func (c *current) onThreeArgumentStringFunction1() (any, error) {
	return string(c.text), nil
}

func (p *parser) callonThreeArgumentStringFunction1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onThreeArgumentStringFunction1()
}

func (c *current) onIsDefined1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsDefined, []interface{}{ex})
}

func (p *parser) callonIsDefined1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsDefined1(stack["ex"])
}

func (c *current) onIsArray1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsArray, []interface{}{ex})
}

func (p *parser) callonIsArray1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsArray1(stack["ex"])
}

func (c *current) onIsBool1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsBool, []interface{}{ex})
}

func (p *parser) callonIsBool1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsBool1(stack["ex"])
}

func (c *current) onIsFiniteNumber1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsFiniteNumber, []interface{}{ex})
}

func (p *parser) callonIsFiniteNumber1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsFiniteNumber1(stack["ex"])
}

func (c *current) onIsInteger1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsInteger, []interface{}{ex})
}

func (p *parser) callonIsInteger1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsInteger1(stack["ex"])
}

func (c *current) onIsNull1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsNull, []interface{}{ex})
}

func (p *parser) callonIsNull1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsNull1(stack["ex"])
}

func (c *current) onIsNumber1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsNumber, []interface{}{ex})
}

func (p *parser) callonIsNumber1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsNumber1(stack["ex"])
}

func (c *current) onIsObject1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsObject, []interface{}{ex})
}

func (p *parser) callonIsObject1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsObject1(stack["ex"])
}

func (c *current) onIsPrimitive1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsPrimitive, []interface{}{ex})
}

func (p *parser) callonIsPrimitive1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsPrimitive1(stack["ex"])
}

func (c *current) onIsString1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsString, []interface{}{ex})
}

func (p *parser) callonIsString1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsString1(stack["ex"])
}

func (c *current) onArrayConcatExpression11(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonArrayConcatExpression11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayConcatExpression11(stack["ex"])
}

func (c *current) onArrayConcatExpression1(arrays, others any) (any, error) {
	return createFunctionCall(parsers.FunctionCallArrayConcat, append([]interface{}{arrays}, others.([]interface{})...))
}

func (p *parser) callonArrayConcatExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayConcatExpression1(stack["arrays"], stack["others"])
}

func (c *current) onArrayLengthExpression1(array any) (any, error) {
	return createFunctionCall(parsers.FunctionCallArrayLength, []interface{}{array})
}

func (p *parser) callonArrayLengthExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayLengthExpression1(stack["array"])
}

func (c *current) onArraySliceExpression16(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonArraySliceExpression16() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArraySliceExpression16(stack["ex"])
}

func (c *current) onArraySliceExpression1(array, start, length any) (any, error) {
	return createFunctionCall(parsers.FunctionCallArraySlice, []interface{}{array, start, length})
}

func (p *parser) callonArraySliceExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArraySliceExpression1(stack["array"], stack["start"], stack["length"])
}

func (c *current) onSetIntersectExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallSetIntersect, []interface{}{set1, set2})
}

func (p *parser) callonSetIntersectExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSetIntersectExpression1(stack["set1"], stack["set2"])
}

func (c *current) onSetUnionExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallSetUnion, []interface{}{set1, set2})
}

func (p *parser) callonSetUnionExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSetUnionExpression1(stack["set1"], stack["set2"])
}

func (c *current) onInFunction14(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonInFunction14() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInFunction14(stack["ex"])
}

func (c *current) onInFunction1(ex1, ex2, others any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIn, append([]interface{}{ex1, ex2}, others.([]interface{})...))
}

func (p *parser) callonInFunction1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInFunction1(stack["ex1"], stack["ex2"], stack["others"])
}

func (c *current) onInteger1() (any, error) {
	return strconv.Atoi(string(c.text))
}

func (p *parser) callonInteger1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInteger1()
}

func (c *current) onStringCharacter2() (any, error) {
	return string(c.text), nil
}

func (p *parser) callonStringCharacter2() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringCharacter2()
}

func (c *current) onStringCharacter9(seq any) (any, error) {
	return seq, nil
}

func (p *parser) callonStringCharacter9() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringCharacter9(stack["seq"])
}

func (c *current) onEscapeCharacter5() (any, error) {
	return "\b", nil
}

func (p *parser) callonEscapeCharacter5() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter5()
}

func (c *current) onEscapeCharacter7() (any, error) {
	return "\f", nil
}

func (p *parser) callonEscapeCharacter7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter7()
}

func (c *current) onEscapeCharacter9() (any, error) {
	return "\n", nil
}

func (p *parser) callonEscapeCharacter9() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter9()
}

func (c *current) onEscapeCharacter11() (any, error) {
	return "\r", nil
}

func (p *parser) callonEscapeCharacter11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter11()
}

func (c *current) onEscapeCharacter13() (any, error) {
	return "\t", nil
}

func (p *parser) callonEscapeCharacter13() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter13()
}

func (c *current) onnon_escape_character1(char any) (any, error) {
	return string(c.text), nil
}

func (p *parser) callonnon_escape_character1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onnon_escape_character1(stack["char"])
}

var (
	// errNoRule is returned when the grammar to parse has no rule.
	errNoRule = errors.New("grammar has no rule")

	// errInvalidEntrypoint is returned when the specified entrypoint rule
	// does not exit.
	errInvalidEntrypoint = errors.New("invalid entrypoint")

	// errInvalidEncoding is returned when the source is not properly
	// utf8-encoded.
	errInvalidEncoding = errors.New("invalid encoding")

	// errMaxExprCnt is used to signal that the maximum number of
	// expressions have been parsed.
	errMaxExprCnt = errors.New("max number of expressions parsed")
)

// Option is a function that can set an option on the parser. It returns
// the previous setting as an Option.
type Option func(*parser) Option

// MaxExpressions creates an Option to stop parsing after the provided
// number of expressions have been parsed, if the value is 0 then the parser will
// parse for as many steps as needed (possibly an infinite number).
//
// The default for maxExprCnt is 0.
func MaxExpressions(maxExprCnt uint64) Option {
	return func(p *parser) Option {
		oldMaxExprCnt := p.maxExprCnt
		p.maxExprCnt = maxExprCnt
		return MaxExpressions(oldMaxExprCnt)
	}
}

// Entrypoint creates an Option to set the rule name to use as entrypoint.
// The rule name must have been specified in the -alternate-entrypoints
// if generating the parser with the -optimize-grammar flag, otherwise
// it may have been optimized out. Passing an empty string sets the
// entrypoint to the first rule in the grammar.
//
// The default is to start parsing at the first rule in the grammar.
func Entrypoint(ruleName string) Option {
	return func(p *parser) Option {
		oldEntrypoint := p.entrypoint
		p.entrypoint = ruleName
		if ruleName == "" {
			p.entrypoint = g.rules[0].name
		}
		return Entrypoint(oldEntrypoint)
	}
}

// Statistics adds a user provided Stats struct to the parser to allow
// the user to process the results after the parsing has finished.
// Also the key for the "no match" counter is set.
//
// Example usage:
//
//	input := "input"
//	stats := Stats{}
//	_, err := Parse("input-file", []byte(input), Statistics(&stats, "no match"))
//	if err != nil {
//	    log.Panicln(err)
//	}
//	b, err := json.MarshalIndent(stats.ChoiceAltCnt, "", "  ")
//	if err != nil {
//	    log.Panicln(err)
//	}
//	fmt.Println(string(b))
func Statistics(stats *Stats, choiceNoMatch string) Option {
	return func(p *parser) Option {
		oldStats := p.Stats
		p.Stats = stats
		oldChoiceNoMatch := p.choiceNoMatch
		p.choiceNoMatch = choiceNoMatch
		if p.Stats.ChoiceAltCnt == nil {
			p.Stats.ChoiceAltCnt = make(map[string]map[string]int)
		}
		return Statistics(oldStats, oldChoiceNoMatch)
	}
}

// Debug creates an Option to set the debug flag to b. When set to true,
// debugging information is printed to stdout while parsing.
//
// The default is false.
func Debug(b bool) Option {
	return func(p *parser) Option {
		old := p.debug
		p.debug = b
		return Debug(old)
	}
}

// Memoize creates an Option to set the memoize flag to b. When set to true,
// the parser will cache all results so each expression is evaluated only
// once. This guarantees linear parsing time even for pathological cases,
// at the expense of more memory and slower times for typical cases.
//
// The default is false.
func Memoize(b bool) Option {
	return func(p *parser) Option {
		old := p.memoize
		p.memoize = b
		return Memoize(old)
	}
}

// AllowInvalidUTF8 creates an Option to allow invalid UTF-8 bytes.
// Every invalid UTF-8 byte is treated as a utf8.RuneError (U+FFFD)
// by character class matchers and is matched by the any matcher.
// The returned matched value, c.text and c.offset are NOT affected.
//
// The default is false.
func AllowInvalidUTF8(b bool) Option {
	return func(p *parser) Option {
		old := p.allowInvalidUTF8
		p.allowInvalidUTF8 = b
		return AllowInvalidUTF8(old)
	}
}

// Recover creates an Option to set the recover flag to b. When set to
// true, this causes the parser to recover from panics and convert it
// to an error. Setting it to false can be useful while debugging to
// access the full stack trace.
//
// The default is true.
func Recover(b bool) Option {
	return func(p *parser) Option {
		old := p.recover
		p.recover = b
		return Recover(old)
	}
}

// GlobalStore creates an Option to set a key to a certain value in
// the globalStore.
func GlobalStore(key string, value any) Option {
	return func(p *parser) Option {
		old := p.cur.globalStore[key]
		p.cur.globalStore[key] = value
		return GlobalStore(key, old)
	}
}

// InitState creates an Option to set a key to a certain value in
// the global "state" store.
func InitState(key string, value any) Option {
	return func(p *parser) Option {
		old := p.cur.state[key]
		p.cur.state[key] = value
		return InitState(key, old)
	}
}

// ParseFile parses the file identified by filename.
func ParseFile(filename string, opts ...Option) (i any, err error) {
	f, err := os.Open(filename)
	if err != nil {
		return nil, err
	}
	defer func() {
		if closeErr := f.Close(); closeErr != nil {
			err = closeErr
		}
	}()
	return ParseReader(filename, f, opts...)
}

// ParseReader parses the data from r using filename as information in the
// error messages.
func ParseReader(filename string, r io.Reader, opts ...Option) (any, error) {
	b, err := io.ReadAll(r)
	if err != nil {
		return nil, err
	}

	return Parse(filename, b, opts...)
}

// Parse parses the data from b using filename as information in the
// error messages.
func Parse(filename string, b []byte, opts ...Option) (any, error) {
	return newParser(filename, b, opts...).parse(g)
}

// position records a position in the text.
type position struct {
	line, col, offset int
}

func (p position) String() string {
	return strconv.Itoa(p.line) + ":" + strconv.Itoa(p.col) + " [" + strconv.Itoa(p.offset) + "]"
}

// savepoint stores all state required to go back to this point in the
// parser.
type savepoint struct {
	position
	rn rune
	w  int
}

type current struct {
	pos  position // start position of the match
	text []byte   // raw text of the match

	// state is a store for arbitrary key,value pairs that the user wants to be
	// tied to the backtracking of the parser.
	// This is always rolled back if a parsing rule fails.
	state storeDict

	// globalStore is a general store for the user to store arbitrary key-value
	// pairs that they need to manage and that they do not want tied to the
	// backtracking of the parser. This is only modified by the user and never
	// rolled back by the parser. It is always up to the user to keep this in a
	// consistent state.
	globalStore storeDict
}

type storeDict map[string]any

// the AST types...

type grammar struct {
	pos   position
	rules []*rule
}

type rule struct {
	pos         position
	name        string
	displayName string
	expr        any
}

type choiceExpr struct {
	pos          position
	alternatives []any
}

type actionExpr struct {
	pos  position
	expr any
	run  func(*parser) (any, error)
}

type recoveryExpr struct {
	pos          position
	expr         any
	recoverExpr  any
	failureLabel []string
}

type seqExpr struct {
	pos   position
	exprs []any
}

type throwExpr struct {
	pos   position
	label string
}

type labeledExpr struct {
	pos   position
	label string
	expr  any
}

type expr struct {
	pos  position
	expr any
}

type (
	andExpr        expr
	notExpr        expr
	zeroOrOneExpr  expr
	zeroOrMoreExpr expr
	oneOrMoreExpr  expr
)

type ruleRefExpr struct {
	pos  position
	name string
}

type stateCodeExpr struct {
	pos position
	run func(*parser) error
}

type andCodeExpr struct {
	pos position
	run func(*parser) (bool, error)
}

type notCodeExpr struct {
	pos position
	run func(*parser) (bool, error)
}

type litMatcher struct {
	pos        position
	val        string
	ignoreCase bool
	want       string
}

type charClassMatcher struct {
	pos             position
	val             string
	basicLatinChars [128]bool
	chars           []rune
	ranges          []rune
	classes         []*unicode.RangeTable
	ignoreCase      bool
	inverted        bool
}

type anyMatcher position

// errList cumulates the errors found by the parser.
type errList []error

func (e *errList) add(err error) {
	*e = append(*e, err)
}

func (e errList) err() error {
	if len(e) == 0 {
		return nil
	}
	e.dedupe()
	return e
}

func (e *errList) dedupe() {
	var cleaned []error
	set := make(map[string]bool)
	for _, err := range *e {
		if msg := err.Error(); !set[msg] {
			set[msg] = true
			cleaned = append(cleaned, err)
		}
	}
	*e = cleaned
}

func (e errList) Error() string {
	switch len(e) {
	case 0:
		return ""
	case 1:
		return e[0].Error()
	default:
		var buf bytes.Buffer

		for i, err := range e {
			if i > 0 {
				buf.WriteRune('\n')
			}
			buf.WriteString(err.Error())
		}
		return buf.String()
	}
}

// parserError wraps an error with a prefix indicating the rule in which
// the error occurred. The original error is stored in the Inner field.
type parserError struct {
	Inner    error
	pos      position
	prefix   string
	expected []string
}

// Error returns the error message.
func (p *parserError) Error() string {
	return p.prefix + ": " + p.Inner.Error()
}

// newParser creates a parser with the specified input source and options.
func newParser(filename string, b []byte, opts ...Option) *parser {
	stats := Stats{
		ChoiceAltCnt: make(map[string]map[string]int),
	}

	p := &parser{
		filename: filename,
		errs:     new(errList),
		data:     b,
		pt:       savepoint{position: position{line: 1}},
		recover:  true,
		cur: current{
			state:       make(storeDict),
			globalStore: make(storeDict),
		},
		maxFailPos:      position{col: 1, line: 1},
		maxFailExpected: make([]string, 0, 20),
		Stats:           &stats,
		// start rule is rule [0] unless an alternate entrypoint is specified
		entrypoint: g.rules[0].name,
	}
	p.setOptions(opts)

	if p.maxExprCnt == 0 {
		p.maxExprCnt = math.MaxUint64
	}

	return p
}

// setOptions applies the options to the parser.
func (p *parser) setOptions(opts []Option) {
	for _, opt := range opts {
		opt(p)
	}
}

type resultTuple struct {
	v   any
	b   bool
	end savepoint
}

const choiceNoMatch = -1

// Stats stores some statistics, gathered during parsing
type Stats struct {
	// ExprCnt counts the number of expressions processed during parsing
	// This value is compared to the maximum number of expressions allowed
	// (set by the MaxExpressions option).
	ExprCnt uint64

	// ChoiceAltCnt is used to count for each ordered choice expression,
	// which alternative is used how may times.
	// These numbers allow to optimize the order of the ordered choice expression
	// to increase the performance of the parser
	//
	// The outer key of ChoiceAltCnt is composed of the name of the rule as well
	// as the line and the column of the ordered choice.
	// The inner key of ChoiceAltCnt is the number (one-based) of the matching alternative.
	// For each alternative the number of matches are counted. If an ordered choice does not
	// match, a special counter is incremented. The name of this counter is set with
	// the parser option Statistics.
	// For an alternative to be included in ChoiceAltCnt, it has to match at least once.
	ChoiceAltCnt map[string]map[string]int
}

type parser struct {
	filename string
	pt       savepoint
	cur      current

	data []byte
	errs *errList

	depth   int
	recover bool
	debug   bool

	memoize bool
	// memoization table for the packrat algorithm:
	// map[offset in source] map[expression or rule] {value, match}
	memo map[int]map[any]resultTuple

	// rules table, maps the rule identifier to the rule node
	rules map[string]*rule
	// variables stack, map of label to value
	vstack []map[string]any
	// rule stack, allows identification of the current rule in errors
	rstack []*rule

	// parse fail
	maxFailPos            position
	maxFailExpected       []string
	maxFailInvertExpected bool

	// max number of expressions to be parsed
	maxExprCnt uint64
	// entrypoint for the parser
	entrypoint string

	allowInvalidUTF8 bool

	*Stats

	choiceNoMatch string
	// recovery expression stack, keeps track of the currently available recovery expression, these are traversed in reverse
	recoveryStack []map[string]any
}

// push a variable set on the vstack.
func (p *parser) pushV() {
	if cap(p.vstack) == len(p.vstack) {
		// create new empty slot in the stack
		p.vstack = append(p.vstack, nil)
	} else {
		// slice to 1 more
		p.vstack = p.vstack[:len(p.vstack)+1]
	}

	// get the last args set
	m := p.vstack[len(p.vstack)-1]
	if m != nil && len(m) == 0 {
		// empty map, all good
		return
	}

	m = make(map[string]any)
	p.vstack[len(p.vstack)-1] = m
}

// pop a variable set from the vstack.
func (p *parser) popV() {
	// if the map is not empty, clear it
	m := p.vstack[len(p.vstack)-1]
	if len(m) > 0 {
		// GC that map
		p.vstack[len(p.vstack)-1] = nil
	}
	p.vstack = p.vstack[:len(p.vstack)-1]
}

// push a recovery expression with its labels to the recoveryStack
func (p *parser) pushRecovery(labels []string, expr any) {
	if cap(p.recoveryStack) == len(p.recoveryStack) {
		// create new empty slot in the stack
		p.recoveryStack = append(p.recoveryStack, nil)
	} else {
		// slice to 1 more
		p.recoveryStack = p.recoveryStack[:len(p.recoveryStack)+1]
	}

	m := make(map[string]any, len(labels))
	for _, fl := range labels {
		m[fl] = expr
	}
	p.recoveryStack[len(p.recoveryStack)-1] = m
}

// pop a recovery expression from the recoveryStack
func (p *parser) popRecovery() {
	// GC that map
	p.recoveryStack[len(p.recoveryStack)-1] = nil

	p.recoveryStack = p.recoveryStack[:len(p.recoveryStack)-1]
}

func (p *parser) print(prefix, s string) string {
	if !p.debug {
		return s
	}

	fmt.Printf("%s %d:%d:%d: %s [%#U]\n",
		prefix, p.pt.line, p.pt.col, p.pt.offset, s, p.pt.rn)
	return s
}

func (p *parser) printIndent(mark string, s string) string {
	return p.print(strings.Repeat(" ", p.depth)+mark, s)
}

func (p *parser) in(s string) string {
	res := p.printIndent(">", s)
	p.depth++
	return res
}

func (p *parser) out(s string) string {
	p.depth--
	return p.printIndent("<", s)
}

func (p *parser) addErr(err error) {
	p.addErrAt(err, p.pt.position, []string{})
}

func (p *parser) addErrAt(err error, pos position, expected []string) {
	var buf bytes.Buffer
	if p.filename != "" {
		buf.WriteString(p.filename)
	}
	if buf.Len() > 0 {
		buf.WriteString(":")
	}
	buf.WriteString(fmt.Sprintf("%d:%d (%d)", pos.line, pos.col, pos.offset))
	if len(p.rstack) > 0 {
		if buf.Len() > 0 {
			buf.WriteString(": ")
		}
		rule := p.rstack[len(p.rstack)-1]
		if rule.displayName != "" {
			buf.WriteString("rule " + rule.displayName)
		} else {
			buf.WriteString("rule " + rule.name)
		}
	}
	pe := &parserError{Inner: err, pos: pos, prefix: buf.String(), expected: expected}
	p.errs.add(pe)
}

func (p *parser) failAt(fail bool, pos position, want string) {
	// process fail if parsing fails and not inverted or parsing succeeds and invert is set
	if fail == p.maxFailInvertExpected {
		if pos.offset < p.maxFailPos.offset {
			return
		}

		if pos.offset > p.maxFailPos.offset {
			p.maxFailPos = pos
			p.maxFailExpected = p.maxFailExpected[:0]
		}

		if p.maxFailInvertExpected {
			want = "!" + want
		}
		p.maxFailExpected = append(p.maxFailExpected, want)
	}
}

// read advances the parser to the next rune.
func (p *parser) read() {
	p.pt.offset += p.pt.w
	rn, n := utf8.DecodeRune(p.data[p.pt.offset:])
	p.pt.rn = rn
	p.pt.w = n
	p.pt.col++
	if rn == '\n' {
		p.pt.line++
		p.pt.col = 0
	}

	if rn == utf8.RuneError && n == 1 { // see utf8.DecodeRune
		if !p.allowInvalidUTF8 {
			p.addErr(errInvalidEncoding)
		}
	}
}

// restore parser position to the savepoint pt.
func (p *parser) restore(pt savepoint) {
	if p.debug {
		defer p.out(p.in("restore"))
	}
	if pt.offset == p.pt.offset {
		return
	}
	p.pt = pt
}

// Cloner is implemented by any value that has a Clone method, which returns a
// copy of the value. This is mainly used for types which are not passed by
// value (e.g map, slice, chan) or structs that contain such types.
//
// This is used in conjunction with the global state feature to create proper
// copies of the state to allow the parser to properly restore the state in
// the case of backtracking.
type Cloner interface {
	Clone() any
}

var statePool = &sync.Pool{
	New: func() any { return make(storeDict) },
}

func (sd storeDict) Discard() {
	for k := range sd {
		delete(sd, k)
	}
	statePool.Put(sd)
}

// clone and return parser current state.
func (p *parser) cloneState() storeDict {
	if p.debug {
		defer p.out(p.in("cloneState"))
	}

	state := statePool.Get().(storeDict)
	for k, v := range p.cur.state {
		if c, ok := v.(Cloner); ok {
			state[k] = c.Clone()
		} else {
			state[k] = v
		}
	}
	return state
}

// restore parser current state to the state storeDict.
// every restoreState should applied only one time for every cloned state
func (p *parser) restoreState(state storeDict) {
	if p.debug {
		defer p.out(p.in("restoreState"))
	}
	p.cur.state.Discard()
	p.cur.state = state
}

// get the slice of bytes from the savepoint start to the current position.
func (p *parser) sliceFrom(start savepoint) []byte {
	return p.data[start.position.offset:p.pt.position.offset]
}

func (p *parser) getMemoized(node any) (resultTuple, bool) {
	if len(p.memo) == 0 {
		return resultTuple{}, false
	}
	m := p.memo[p.pt.offset]
	if len(m) == 0 {
		return resultTuple{}, false
	}
	res, ok := m[node]
	return res, ok
}

func (p *parser) setMemoized(pt savepoint, node any, tuple resultTuple) {
	if p.memo == nil {
		p.memo = make(map[int]map[any]resultTuple)
	}
	m := p.memo[pt.offset]
	if m == nil {
		m = make(map[any]resultTuple)
		p.memo[pt.offset] = m
	}
	m[node] = tuple
}

func (p *parser) buildRulesTable(g *grammar) {
	p.rules = make(map[string]*rule, len(g.rules))
	for _, r := range g.rules {
		p.rules[r.name] = r
	}
}

func (p *parser) parse(g *grammar) (val any, err error) {
	if len(g.rules) == 0 {
		p.addErr(errNoRule)
		return nil, p.errs.err()
	}

	// TODO : not super critical but this could be generated
	p.buildRulesTable(g)

	if p.recover {
		// panic can be used in action code to stop parsing immediately
		// and return the panic as an error.
		defer func() {
			if e := recover(); e != nil {
				if p.debug {
					defer p.out(p.in("panic handler"))
				}
				val = nil
				switch e := e.(type) {
				case error:
					p.addErr(e)
				default:
					p.addErr(fmt.Errorf("%v", e))
				}
				err = p.errs.err()
			}
		}()
	}

	startRule, ok := p.rules[p.entrypoint]
	if !ok {
		p.addErr(errInvalidEntrypoint)
		return nil, p.errs.err()
	}

	p.read() // advance to first rune
	val, ok = p.parseRuleWrap(startRule)
	if !ok {
		if len(*p.errs) == 0 {
			// If parsing fails, but no errors have been recorded, the expected values
			// for the farthest parser position are returned as error.
			maxFailExpectedMap := make(map[string]struct{}, len(p.maxFailExpected))
			for _, v := range p.maxFailExpected {
				maxFailExpectedMap[v] = struct{}{}
			}
			expected := make([]string, 0, len(maxFailExpectedMap))
			eof := false
			if _, ok := maxFailExpectedMap["!."]; ok {
				delete(maxFailExpectedMap, "!.")
				eof = true
			}
			for k := range maxFailExpectedMap {
				expected = append(expected, k)
			}
			sort.Strings(expected)
			if eof {
				expected = append(expected, "EOF")
			}
			p.addErrAt(errors.New("no match found, expected: "+listJoin(expected, ", ", "or")), p.maxFailPos, expected)
		}

		return nil, p.errs.err()
	}
	return val, p.errs.err()
}

func listJoin(list []string, sep string, lastSep string) string {
	switch len(list) {
	case 0:
		return ""
	case 1:
		return list[0]
	default:
		return strings.Join(list[:len(list)-1], sep) + " " + lastSep + " " + list[len(list)-1]
	}
}

func (p *parser) parseRuleMemoize(rule *rule) (any, bool) {
	res, ok := p.getMemoized(rule)
	if ok {
		p.restore(res.end)
		return res.v, res.b
	}

	startMark := p.pt
	val, ok := p.parseRule(rule)
	p.setMemoized(startMark, rule, resultTuple{val, ok, p.pt})

	return val, ok
}

func (p *parser) parseRuleWrap(rule *rule) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseRule " + rule.name))
	}
	var (
		val       any
		ok        bool
		startMark = p.pt
	)

	if p.memoize {
		val, ok = p.parseRuleMemoize(rule)
	} else {
		val, ok = p.parseRule(rule)
	}

	if ok && p.debug {
		p.printIndent("MATCH", string(p.sliceFrom(startMark)))
	}
	return val, ok
}

func (p *parser) parseRule(rule *rule) (any, bool) {
	p.rstack = append(p.rstack, rule)
	p.pushV()
	val, ok := p.parseExprWrap(rule.expr)
	p.popV()
	p.rstack = p.rstack[:len(p.rstack)-1]
	return val, ok
}

func (p *parser) parseExprWrap(expr any) (any, bool) {
	var pt savepoint

	if p.memoize {
		res, ok := p.getMemoized(expr)
		if ok {
			p.restore(res.end)
			return res.v, res.b
		}
		pt = p.pt
	}

	val, ok := p.parseExpr(expr)

	if p.memoize {
		p.setMemoized(pt, expr, resultTuple{val, ok, p.pt})
	}
	return val, ok
}

func (p *parser) parseExpr(expr any) (any, bool) {
	p.ExprCnt++
	if p.ExprCnt > p.maxExprCnt {
		panic(errMaxExprCnt)
	}

	var val any
	var ok bool
	switch expr := expr.(type) {
	case *actionExpr:
		val, ok = p.parseActionExpr(expr)
	case *andCodeExpr:
		val, ok = p.parseAndCodeExpr(expr)
	case *andExpr:
		val, ok = p.parseAndExpr(expr)
	case *anyMatcher:
		val, ok = p.parseAnyMatcher(expr)
	case *charClassMatcher:
		val, ok = p.parseCharClassMatcher(expr)
	case *choiceExpr:
		val, ok = p.parseChoiceExpr(expr)
	case *labeledExpr:
		val, ok = p.parseLabeledExpr(expr)
	case *litMatcher:
		val, ok = p.parseLitMatcher(expr)
	case *notCodeExpr:
		val, ok = p.parseNotCodeExpr(expr)
	case *notExpr:
		val, ok = p.parseNotExpr(expr)
	case *oneOrMoreExpr:
		val, ok = p.parseOneOrMoreExpr(expr)
	case *recoveryExpr:
		val, ok = p.parseRecoveryExpr(expr)
	case *ruleRefExpr:
		val, ok = p.parseRuleRefExpr(expr)
	case *seqExpr:
		val, ok = p.parseSeqExpr(expr)
	case *stateCodeExpr:
		val, ok = p.parseStateCodeExpr(expr)
	case *throwExpr:
		val, ok = p.parseThrowExpr(expr)
	case *zeroOrMoreExpr:
		val, ok = p.parseZeroOrMoreExpr(expr)
	case *zeroOrOneExpr:
		val, ok = p.parseZeroOrOneExpr(expr)
	default:
		panic(fmt.Sprintf("unknown expression type %T", expr))
	}
	return val, ok
}

func (p *parser) parseActionExpr(act *actionExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseActionExpr"))
	}

	start := p.pt
	val, ok := p.parseExprWrap(act.expr)
	if ok {
		p.cur.pos = start.position
		p.cur.text = p.sliceFrom(start)
		state := p.cloneState()
		actVal, err := act.run(p)
		if err != nil {
			p.addErrAt(err, start.position, []string{})
		}
		p.restoreState(state)

		val = actVal
	}
	if ok && p.debug {
		p.printIndent("MATCH", string(p.sliceFrom(start)))
	}
	return val, ok
}

func (p *parser) parseAndCodeExpr(and *andCodeExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseAndCodeExpr"))
	}

	state := p.cloneState()

	ok, err := and.run(p)
	if err != nil {
		p.addErr(err)
	}
	p.restoreState(state)

	return nil, ok
}

func (p *parser) parseAndExpr(and *andExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseAndExpr"))
	}

	pt := p.pt
	state := p.cloneState()
	p.pushV()
	_, ok := p.parseExprWrap(and.expr)
	p.popV()
	p.restoreState(state)
	p.restore(pt)

	return nil, ok
}

func (p *parser) parseAnyMatcher(any *anyMatcher) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseAnyMatcher"))
	}

	if p.pt.rn == utf8.RuneError && p.pt.w == 0 {
		// EOF - see utf8.DecodeRune
		p.failAt(false, p.pt.position, ".")
		return nil, false
	}
	start := p.pt
	p.read()
	p.failAt(true, start.position, ".")
	return p.sliceFrom(start), true
}

func (p *parser) parseCharClassMatcher(chr *charClassMatcher) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseCharClassMatcher"))
	}

	cur := p.pt.rn
	start := p.pt

	// can't match EOF
	if cur == utf8.RuneError && p.pt.w == 0 { // see utf8.DecodeRune
		p.failAt(false, start.position, chr.val)
		return nil, false
	}

	if chr.ignoreCase {
		cur = unicode.ToLower(cur)
	}

	// try to match in the list of available chars
	for _, rn := range chr.chars {
		if rn == cur {
			if chr.inverted {
				p.failAt(false, start.position, chr.val)
				return nil, false
			}
			p.read()
			p.failAt(true, start.position, chr.val)
			return p.sliceFrom(start), true
		}
	}

	// try to match in the list of ranges
	for i := 0; i < len(chr.ranges); i += 2 {
		if cur >= chr.ranges[i] && cur <= chr.ranges[i+1] {
			if chr.inverted {
				p.failAt(false, start.position, chr.val)
				return nil, false
			}
			p.read()
			p.failAt(true, start.position, chr.val)
			return p.sliceFrom(start), true
		}
	}

	// try to match in the list of Unicode classes
	for _, cl := range chr.classes {
		if unicode.Is(cl, cur) {
			if chr.inverted {
				p.failAt(false, start.position, chr.val)
				return nil, false
			}
			p.read()
			p.failAt(true, start.position, chr.val)
			return p.sliceFrom(start), true
		}
	}

	if chr.inverted {
		p.read()
		p.failAt(true, start.position, chr.val)
		return p.sliceFrom(start), true
	}
	p.failAt(false, start.position, chr.val)
	return nil, false
}

func (p *parser) incChoiceAltCnt(ch *choiceExpr, altI int) {
	choiceIdent := fmt.Sprintf("%s %d:%d", p.rstack[len(p.rstack)-1].name, ch.pos.line, ch.pos.col)
	m := p.ChoiceAltCnt[choiceIdent]
	if m == nil {
		m = make(map[string]int)
		p.ChoiceAltCnt[choiceIdent] = m
	}
	// We increment altI by 1, so the keys do not start at 0
	alt := strconv.Itoa(altI + 1)
	if altI == choiceNoMatch {
		alt = p.choiceNoMatch
	}
	m[alt]++
}

func (p *parser) parseChoiceExpr(ch *choiceExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseChoiceExpr"))
	}

	for altI, alt := range ch.alternatives {
		// dummy assignment to prevent compile error if optimized
		_ = altI

		state := p.cloneState()

		p.pushV()
		val, ok := p.parseExprWrap(alt)
		p.popV()
		if ok {
			p.incChoiceAltCnt(ch, altI)
			return val, ok
		}
		p.restoreState(state)
	}
	p.incChoiceAltCnt(ch, choiceNoMatch)
	return nil, false
}

func (p *parser) parseLabeledExpr(lab *labeledExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseLabeledExpr"))
	}

	p.pushV()
	val, ok := p.parseExprWrap(lab.expr)
	p.popV()
	if ok && lab.label != "" {
		m := p.vstack[len(p.vstack)-1]
		m[lab.label] = val
	}
	return val, ok
}

func (p *parser) parseLitMatcher(lit *litMatcher) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseLitMatcher"))
	}

	start := p.pt
	for _, want := range lit.val {
		cur := p.pt.rn
		if lit.ignoreCase {
			cur = unicode.ToLower(cur)
		}
		if cur != want {
			p.failAt(false, start.position, lit.want)
			p.restore(start)
			return nil, false
		}
		p.read()
	}
	p.failAt(true, start.position, lit.want)
	return p.sliceFrom(start), true
}

func (p *parser) parseNotCodeExpr(not *notCodeExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseNotCodeExpr"))
	}

	state := p.cloneState()

	ok, err := not.run(p)
	if err != nil {
		p.addErr(err)
	}
	p.restoreState(state)

	return nil, !ok
}

func (p *parser) parseNotExpr(not *notExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseNotExpr"))
	}

	pt := p.pt
	state := p.cloneState()
	p.pushV()
	p.maxFailInvertExpected = !p.maxFailInvertExpected
	_, ok := p.parseExprWrap(not.expr)
	p.maxFailInvertExpected = !p.maxFailInvertExpected
	p.popV()
	p.restoreState(state)
	p.restore(pt)

	return nil, !ok
}

func (p *parser) parseOneOrMoreExpr(expr *oneOrMoreExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseOneOrMoreExpr"))
	}

	var vals []any

	for {
		p.pushV()
		val, ok := p.parseExprWrap(expr.expr)
		p.popV()
		if !ok {
			if len(vals) == 0 {
				// did not match once, no match
				return nil, false
			}
			return vals, true
		}
		vals = append(vals, val)
	}
}

func (p *parser) parseRecoveryExpr(recover *recoveryExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseRecoveryExpr (" + strings.Join(recover.failureLabel, ",") + ")"))
	}

	p.pushRecovery(recover.failureLabel, recover.recoverExpr)
	val, ok := p.parseExprWrap(recover.expr)
	p.popRecovery()

	return val, ok
}

func (p *parser) parseRuleRefExpr(ref *ruleRefExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseRuleRefExpr " + ref.name))
	}

	if ref.name == "" {
		panic(fmt.Sprintf("%s: invalid rule: missing name", ref.pos))
	}

	rule := p.rules[ref.name]
	if rule == nil {
		p.addErr(fmt.Errorf("undefined rule: %s", ref.name))
		return nil, false
	}
	return p.parseRuleWrap(rule)
}

func (p *parser) parseSeqExpr(seq *seqExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseSeqExpr"))
	}

	vals := make([]any, 0, len(seq.exprs))

	pt := p.pt
	state := p.cloneState()
	for _, expr := range seq.exprs {
		val, ok := p.parseExprWrap(expr)
		if !ok {
			p.restoreState(state)
			p.restore(pt)
			return nil, false
		}
		vals = append(vals, val)
	}
	return vals, true
}

func (p *parser) parseStateCodeExpr(state *stateCodeExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseStateCodeExpr"))
	}

	err := state.run(p)
	if err != nil {
		p.addErr(err)
	}
	return nil, true
}

func (p *parser) parseThrowExpr(expr *throwExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseThrowExpr"))
	}

	for i := len(p.recoveryStack) - 1; i >= 0; i-- {
		if recoverExpr, ok := p.recoveryStack[i][expr.label]; ok {
			if val, ok := p.parseExprWrap(recoverExpr); ok {
				return val, ok
			}
		}
	}

	return nil, false
}

func (p *parser) parseZeroOrMoreExpr(expr *zeroOrMoreExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseZeroOrMoreExpr"))
	}

	var vals []any

	for {
		p.pushV()
		val, ok := p.parseExprWrap(expr.expr)
		p.popV()
		if !ok {
			return vals, true
		}
		vals = append(vals, val)
	}
}

func (p *parser) parseZeroOrOneExpr(expr *zeroOrOneExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseZeroOrOneExpr"))
	}

	p.pushV()
	val, _ := p.parseExprWrap(expr.expr)
	p.popV()
	// whether it matched or not, consider it a match
	return val, true
}
